searchData={"items":[{"type":"module","title":":benchee","doc":"High-Level interface for more convenient usage from Erlang. Same as `Benchee`.","ref":":benchee.html"},{"type":"function","title":":benchee.benchmark/3","doc":"","ref":":benchee.html#benchmark/3"},{"type":"function","title":":benchee.collect/1","doc":"","ref":":benchee.html#collect/1"},{"type":"function","title":":benchee.init/0","doc":"","ref":":benchee.html#init/0"},{"type":"function","title":":benchee.init/1","doc":"","ref":":benchee.html#init/1"},{"type":"function","title":":benchee.load/1","doc":"","ref":":benchee.html#load/1"},{"type":"function","title":":benchee.profile/1","doc":"","ref":":benchee.html#profile/1"},{"type":"function","title":":benchee.relative_statistics/1","doc":"","ref":":benchee.html#relative_statistics/1"},{"type":"function","title":":benchee.report/1","doc":"A convenience function designed for loading saved benchmarks and running formatters on them.\n\nBasically takes the input of the map of jobs away from you and skips unnecessary steps with\nthat data missing (aka not running benchmarks, only running relative statistics).\n\nYou can use config options as normal, but some options related to benchmarking won't take\neffect (such as `:time`). The `:load` option however is mandatory to use, as you need to\nload some benchmarks to report on them.","ref":":benchee.html#report/1"},{"type":"function","title":"Usage - :benchee.report/1","doc":"Benchee.report(load: [\"benchmark-*.benchee\"])","ref":":benchee.html#report/1-usage"},{"type":"function","title":":benchee.run/2","doc":"Run benchmark jobs defined by a map and optionally provide configuration\noptions.\n\nBenchmarks are defined as a map where the keys are a name for the given\nfunction and the values are the functions to benchmark. Users can configure\nthe run by passing a keyword list as the second argument. For more\ninformation on configuration see `Benchee.Configuration.init/1`.","ref":":benchee.html#run/2"},{"type":"function","title":"Examples - :benchee.run/2","doc":"Benchee.run(\n      %{\n        \"My Benchmark\" => fn -> 1 + 1 end,\n        \"My other benchmrk\" => fn -> [1] ++ [1] end\n      },\n      warmup: 2,\n      time: 3\n    )","ref":":benchee.html#run/2-examples"},{"type":"function","title":":benchee.statistics/1","doc":"","ref":":benchee.html#statistics/1"},{"type":"function","title":":benchee.system/1","doc":"","ref":":benchee.html#system/1"},{"type":"module","title":"Benchee","doc":"Top level module providing convenience access to needed functions as well\nas the very high level `Benchee.run` API.\n\nIntended Elixir interface.","ref":"Benchee.html"},{"type":"function","title":"Benchee.benchmark/3","doc":"","ref":"Benchee.html#benchmark/3"},{"type":"function","title":"Benchee.collect/1","doc":"","ref":"Benchee.html#collect/1"},{"type":"function","title":"Benchee.init/0","doc":"","ref":"Benchee.html#init/0"},{"type":"function","title":"Benchee.init/1","doc":"","ref":"Benchee.html#init/1"},{"type":"function","title":"Benchee.load/1","doc":"","ref":"Benchee.html#load/1"},{"type":"function","title":"Benchee.profile/1","doc":"","ref":"Benchee.html#profile/1"},{"type":"function","title":"Benchee.relative_statistics/1","doc":"","ref":"Benchee.html#relative_statistics/1"},{"type":"function","title":"Benchee.report/1","doc":"A convenience function designed for loading saved benchmarks and running formatters on them.\n\nBasically takes the input of the map of jobs away from you and skips unnecessary steps with\nthat data missing (aka not running benchmarks, only running relative statistics).\n\nYou can use config options as normal, but some options related to benchmarking won't take\neffect (such as `:time`). The `:load` option however is mandatory to use, as you need to\nload some benchmarks to report on them.","ref":"Benchee.html#report/1"},{"type":"function","title":"Usage - Benchee.report/1","doc":"Benchee.report(load: [\"benchmark-*.benchee\"])","ref":"Benchee.html#report/1-usage"},{"type":"function","title":"Benchee.run/2","doc":"Run benchmark jobs defined by a map and optionally provide configuration\noptions.\n\nBenchmarks are defined as a map where the keys are a name for the given\nfunction and the values are the functions to benchmark. Users can configure\nthe run by passing a keyword list as the second argument. For more\ninformation on configuration see `Benchee.Configuration.init/1`.","ref":"Benchee.html#run/2"},{"type":"function","title":"Examples - Benchee.run/2","doc":"Benchee.run(\n      %{\n        \"My Benchmark\" => fn -> 1 + 1 end,\n        \"My other benchmrk\" => fn -> [1] ++ [1] end\n      },\n      warmup: 2,\n      time: 3\n    )","ref":"Benchee.html#run/2-examples"},{"type":"function","title":"Benchee.statistics/1","doc":"","ref":"Benchee.html#statistics/1"},{"type":"function","title":"Benchee.system/1","doc":"","ref":"Benchee.html#system/1"},{"type":"module","title":"Benchee.Benchmark","doc":"Functions related to building and running benchmarking scenarios.\nExposes `benchmark/4` and `collect/3` functions.","ref":"Benchee.Benchmark.html"},{"type":"function","title":"Benchee.Benchmark.benchmark/4","doc":"Takes the current suite and adds a new benchmarking scenario (represented by a\n%Scenario{} struct) with the given name and function to the suite's scenarios.\nIf there are inputs in the suite's config, a scenario will be added for the given\nfunction for each input.","ref":"Benchee.Benchmark.html#benchmark/4"},{"type":"function","title":"Benchee.Benchmark.collect/3","doc":"Kicks off the benchmarking of all scenarios defined in the given suite.\n\nHence, this might take a while ;) Passes a list of scenarios and a scenario context to our\nbenchmark runner. For more information on how benchmarks are actually run, see the\n`Benchee.Benchmark.Runner` code (API considered private).","ref":"Benchee.Benchmark.html#collect/3"},{"type":"function","title":"Benchee.Benchmark.no_input/0","doc":"Public access for the special key representing no input for a scenario.","ref":"Benchee.Benchmark.html#no_input/0"},{"type":"module","title":"Benchee.Benchmark.BenchmarkConfig","doc":"Benchmark Configuration, practically a sub set of `Benchee.Configuration`\n\n`Benchee.Configuration` holds too much data that we don't want to send into the benchmarking\nprocesses - inputs being potentially huge. Hence, we take the sub set the benchmarks need and\nput it in here. Since this is a benchmarking library, to no one's surprise these are a lot of\nthem.\nSee: https://github.com/bencheeorg/benchee/issues/412","ref":"Benchee.Benchmark.BenchmarkConfig.html"},{"type":"function","title":"Benchee.Benchmark.BenchmarkConfig.from/1","doc":"","ref":"Benchee.Benchmark.BenchmarkConfig.html#from/1"},{"type":"type","title":"Benchee.Benchmark.BenchmarkConfig.t/0","doc":"","ref":"Benchee.Benchmark.BenchmarkConfig.html#t:t/0"},{"type":"module","title":"Benchee.Benchmark.Collect.Profile","doc":"Collect/generate a profile.\n\nThe most unusual collector, as it doesn't return measured values really.\n\nIt still goes around and gathers data about a passed in function and so made sense\nto put it into similar confines.","ref":"Benchee.Benchmark.Collect.Profile.html"},{"type":"function","title":"Benchee.Benchmark.Collect.Profile.collect/2","doc":"","ref":"Benchee.Benchmark.Collect.Profile.html#collect/2"},{"type":"module","title":"Benchee.Benchmark.Hooks","doc":"Internal module to support hooks functionality.","ref":"Benchee.Benchmark.Hooks.html"},{"type":"function","title":"Benchee.Benchmark.Hooks.run_after_each/3","doc":"","ref":"Benchee.Benchmark.Hooks.html#run_after_each/3"},{"type":"function","title":"Benchee.Benchmark.Hooks.run_after_scenario/2","doc":"","ref":"Benchee.Benchmark.Hooks.html#run_after_scenario/2"},{"type":"function","title":"Benchee.Benchmark.Hooks.run_before_each/2","doc":"","ref":"Benchee.Benchmark.Hooks.html#run_before_each/2"},{"type":"function","title":"Benchee.Benchmark.Hooks.run_before_scenario/2","doc":"","ref":"Benchee.Benchmark.Hooks.html#run_before_scenario/2"},{"type":"type","title":"Benchee.Benchmark.Hooks.hook_function/0","doc":"","ref":"Benchee.Benchmark.Hooks.html#t:hook_function/0"},{"type":"module","title":"Benchee.Benchmark.RunOnce","doc":"All that you need to run a function once, hooks and all.\n\nUsed for the `pre_check` functionality as well as profiling.","ref":"Benchee.Benchmark.RunOnce.html"},{"type":"function","title":"Benchee.Benchmark.RunOnce.run/3","doc":"","ref":"Benchee.Benchmark.RunOnce.html#run/3"},{"type":"module","title":"Benchee.Benchmark.Runner","doc":"Internal module \"running\" a scenario, measuring all defined measurements.","ref":"Benchee.Benchmark.Runner.html"},{"type":"function","title":"Benchee.Benchmark.Runner.collect/3","doc":"Takes one measure with the given collector.\n\nCorrectly dispatches based on the number of iterations to perform.","ref":"Benchee.Benchmark.Runner.html#collect/3"},{"type":"function","title":"Benchee.Benchmark.Runner.main_function/2","doc":"","ref":"Benchee.Benchmark.Runner.html#main_function/2"},{"type":"function","title":"Benchee.Benchmark.Runner.measure_and_report_function_call_overhead/1","doc":"","ref":"Benchee.Benchmark.Runner.html#measure_and_report_function_call_overhead/1"},{"type":"function","title":"Benchee.Benchmark.Runner.run_scenarios/2","doc":"Executes the benchmarks defined before by first running the defined functions\nfor `warmup` time without gathering results and them running them for `time`\ngathering their run times.\n\nThis means the total run time of a single benchmarking scenario is warmup +\ntime.\n\nWarmup is usually important for run times with JIT but it seems to have some\neffect on the BEAM as well.\n\nThere will be `parallel` processes spawned executing the benchmark job in\nparallel.","ref":"Benchee.Benchmark.Runner.html#run_scenarios/2"},{"type":"module","title":"Benchee.Benchmark.ScenarioContext","doc":"Internal struct the runner & related modules deal with to run a scenario.\n\nPractically bundles information the runner needs to be aware of while running\na scenario such as the current_time, end_time, printer, input, function call\noverhead etc.","ref":"Benchee.Benchmark.ScenarioContext.html"},{"type":"type","title":"Benchee.Benchmark.ScenarioContext.t/0","doc":"","ref":"Benchee.Benchmark.ScenarioContext.html#t:t/0"},{"type":"module","title":"Benchee.CollectionData","doc":"The unified data structure for a given collection of data.\n\nConsists of the recorded `samples` and the statistics computed from them.","ref":"Benchee.CollectionData.html"},{"type":"type","title":"Benchee.CollectionData.t/0","doc":"Samples and statistics.\n\nStatistics might only come later when they are computed.","ref":"Benchee.CollectionData.html#t:t/0"},{"type":"module","title":"Benchee.Configuration","doc":"Functions to handle the configuration of Benchee, exposes `init/1` function.","ref":"Benchee.Configuration.html"},{"type":"function","title":"Benchee.Configuration.init/1","doc":"Returns the initial benchmark configuration for Benchee, composed of defaults\nand an optional custom configuration.\n\nConfiguration times are given in seconds, but are converted to microseconds\ninternally.\n\nFor a list of all possible options see `t:user_configuration/0`","ref":"Benchee.Configuration.html#init/1"},{"type":"function","title":"Examples - Benchee.Configuration.init/1","doc":"iex> init()\n    %Benchee.Suite{\n      configuration:\n        %Benchee.Configuration{\n          parallel: 1,\n          time: 5_000_000_000.0,\n          warmup: 2_000_000_000.0,\n          inputs: nil,\n          input_names: [],\n          save: false,\n          load: false,\n          formatters: [Benchee.Formatters.Console],\n          print: %{\n            benchmarking: true,\n            fast_warning: true,\n            configuration: true\n          },\n          percentiles: [50, 99],\n          unit_scaling: :best,\n          assigns: %{},\n          before_each: nil,\n          after_each: nil,\n          before_scenario: nil,\n          after_scenario: nil\n        },\n      system: nil,\n      scenarios: []\n    }\n\n    iex> init(time: 1, warmup: 0.2)\n    %Benchee.Suite{\n      configuration:\n        %Benchee.Configuration{\n          parallel: 1,\n          time: 1_000_000_000.0,\n          warmup: 200_000_000.0,\n          inputs: nil,\n          input_names: [],\n          save: false,\n          load: false,\n          formatters: [Benchee.Formatters.Console],\n          print: %{\n            benchmarking: true,\n            fast_warning: true,\n            configuration: true\n          },\n          percentiles: [50, 99],\n          unit_scaling: :best,\n          assigns: %{},\n          before_each: nil,\n          after_each: nil,\n          before_scenario: nil,\n          after_scenario: nil\n        },\n      system: nil,\n      scenarios: []\n    }\n\n    iex> init(\n    ...>   parallel: 2,\n    ...>   time: 1,\n    ...>   warmup: 0.2,\n    ...>   formatters: [&IO.puts/1],\n    ...>   print: [fast_warning: false],\n    ...>   inputs: %{\"Small\" => 5, \"Big\" => 9999},\n    ...>   unit_scaling: :smallest)\n    %Benchee.Suite{\n      configuration:\n        %Benchee.Configuration{\n          parallel: 2,\n          time: 1_000_000_000.0,\n          warmup: 200_000_000.0,\n          inputs: [{\"Big\", 9999}, {\"Small\", 5}],\n          input_names: [\"Big\", \"Small\"],\n          save: false,\n          load: false,\n          formatters: [&IO.puts/1],\n          print: %{\n            benchmarking: true,\n            fast_warning: false,\n            configuration: true\n          },\n          percentiles: [50, 99],\n          unit_scaling: :smallest,\n          assigns: %{},\n          before_each: nil,\n          after_each: nil,\n          before_scenario: nil,\n          after_scenario: nil\n        },\n      system: nil,\n      scenarios: []\n    }","ref":"Benchee.Configuration.html#init/1-examples"},{"type":"type","title":"Benchee.Configuration.t/0","doc":"Generated configuration struct from the user supplied configuration options.\n\nFilled in with a lot of defaults. Also notably every option is already converted to\na map or struct at this point for easier handling in Benchee.","ref":"Benchee.Configuration.html#t:t/0"},{"type":"type","title":"Benchee.Configuration.user_configuration/0","doc":"The configuration supplied by the user as either a map or a keyword list\n\nPossible options are:\n\nPossible options:\n\n  * `warmup` - the time in seconds for which a benchmarking job should be run\n  without measuring times before \"real\" measurements start. This simulates a\n  _\"warm\"_ running system. Defaults to 2.\n  * `time` - the time in seconds for how long each individual benchmarking job\n  should be run for measuring the execution times (run time performance).\n  Defaults to 5.\n  * `memory_time` - the time in seconds for how long memory measurements\n  should be conducted. Defaults to 0 (turned off).\n  * `inputs` - a map from descriptive input names to some different input,\n  your benchmarking jobs will then be run with each of these inputs. For this\n  to work your benchmarking function gets the current input passed in as an\n  argument into the function. Defaults to `nil`, aka no input specified and\n  functions are called without an argument.\n  * `title` - this option is purely cosmetic. If you would like to add a\n  title with some meaning to a given suite, you can do so by providing\n  a single string here. This is only for use by formatters.\n  * `formatters` - list of formatters either as a module implementing the formatter\n  behaviour, a tuple of said module and options it should take or formatter\n  functions. They are run when using `Benchee.run/2` or you can invoktem them\n  through `Benchee.Formatter.output/1`. Functions need to accept one argument (which\n  is the benchmarking suite with all data) and then use that to produce output. Used\n  for plugins. Defaults to the builtin console formatter\n  `Benchee.Formatters.Console`. See [Formatters](#formatters).\n  * `pre_check` - whether or not to run each job with each input - including all\n  given before or after scenario or each hooks - before the benchmarks are\n  measured to ensure that your code executes without error. This can save time\n  while developing your suites. Defaults to `false`.\n  * `parallel`   - each the function of each job will be executed in\n  `parallel` number processes. If `parallel` is `4` then 4 processes will be\n  spawned that all execute the _same_ function for the given time. When these\n  finish/the time is up 4 new processes will be spawned for the next\n  job/function. This gives you more data in the same time, but also puts a\n  load on the system interfering with benchmark results. For more on the pros\n  and cons of parallel benchmarking [check the\n  wiki](https://github.com/bencheeorg/benchee/wiki/Parallel-Benchmarking).\n  Defaults to 1 (no parallel execution).\n  * `save` - specify a `path` where to store the results of the current\n  benchmarking suite, tagged with the specified `tag`.\n  * `load` - load saved suit or suits to compare your current benchmarks\n  against. Can be a string or a list of strings or patterns.\n  * `print` - a map from atoms to `true` or `false` to configure if the\n  output identified by the atom will be printed. All options are enabled by\n  default (true). Options are:\n    * `:benchmarking`  - print when Benchee starts benchmarking a new job\n    (Benchmarking name ..) as well as when statistics are being calculated\n    or formatting begins.\n    * `:configuration` - a summary of configured benchmarking options\n    including estimated total run time is printed before benchmarking starts\n    * `:fast_warning`  - warnings are displayed if functions are executed\n    too fast leading to inaccurate measures\n  * `console` - options for the built-in console formatter:\n    * `:comparison`   - if the comparison of the different benchmarking jobs\n    (x times slower than) is shown (true/false). Enabled by default.\n    * `extended_statistics` - display more statistics, aka `minimum`,\n    `maximum`, `sample_size` and `mode`. Disabled by default.\n  * `percentiles` - if you are using extended statistics and want to see the\n  results for certain percentiles of results beyond just the median.\n  Defaults to [50, 99] to calculate the 50th and 99th percentiles.\n  * `:unit_scaling` - the strategy for choosing a unit for durations and\n  counts. May or may not be implemented by a given formatter (The console\n  formatter implements it). When scaling a value, Benchee finds the \"best fit\"\n  unit (the largest unit for which the result is at least 1). For example,\n  1_200_000 scales to `1.2 M`, while `800_000` scales to `800 K`. The\n  `unit_scaling` strategy determines how Benchee chooses the best fit unit for\n  an entire list of values, when the individual values in the list may have\n  different best fit units. There are four strategies, defaulting to `:best`:\n    * `:best`     - the most frequent best fit unit will be used, a tie\n    will result in the larger unit being selected.\n    * `:largest`  - the largest best fit unit will be used (i.e. thousand\n    and seconds if values are large enough).\n    * `:smallest` - the smallest best fit unit will be used (i.e.\n    millisecond and one)\n    * `:none`     - no unit scaling will occur. Durations will be displayed\n    in microseconds, and counts will be displayed in ones (this is\n    equivalent to the behaviour Benchee had pre 0.5.0)\n  * `:before_scenario`/`after_scenario`/`before_each`/`after_each` - read up on them in the hooks section in the README\n  * `:measure_function_call_overhead` - Measure how long an empty function call takes and deduct this from each measure run time. This overhead should be negligible for all but the most micro benchmarks. Defaults to false.\n  * `profile_after` - accepts any of the following options:\n    * a boolean   - `true` will enable profiling with the default profiler\n    (`:eprof`) and `false` will disable profiling. Defaults to `false`.\n    * a profiler  - either as a tuple of `{profiler, opts}` (e.g., `{:fprof, [sort: :own]}`)\n    or just the profiler (e.g., `:fprof`), which is equivalent to `{profiler, []}`. The accepted built-in profilers are\n    [`:cprof`](https://hexdocs.pm/mix/Mix.Tasks.Profile.Cprof.html),\n    [`:eprof`](https://hexdocs.pm/mix/Mix.Tasks.Profile.Eprof.html) and\n    [`:fprof`](https://hexdocs.pm/mix/Mix.Tasks.Profile.Fprof.html).","ref":"Benchee.Configuration.html#t:user_configuration/0"},{"type":"module","title":"Benchee.Conversion","doc":"Integration of the conversion of multiple units with Benchee.\n\nCan be used by plugins to use Benchee unit scaling logic.","ref":"Benchee.Conversion.html"},{"type":"function","title":"Benchee.Conversion.units/2","doc":"Takes scenarios and a given scaling_strategy, returns the best units for the\ngiven scaling strategy. The return value changes based on whether you want\nunits for run time or memory usage.\n\nThe units can then be passed on to the appropriate `format` calls to format\nthe output of arbitrary values with the right unit.","ref":"Benchee.Conversion.html#units/2"},{"type":"function","title":"Examples - Benchee.Conversion.units/2","doc":"iex> statistics = %Benchee.Statistics{average: 1_000_000.0, ips: 1000.0}\n    iex> scenario = %Benchee.Scenario{\n    ...>   run_time_data: %Benchee.CollectionData{statistics: statistics},\n    ...>   memory_usage_data: %Benchee.CollectionData{statistics: statistics},\n    ...>   reductions_data: %Benchee.CollectionData{statistics: statistics}\n    ...> }\n    iex> Benchee.Conversion.units([scenario], :best)\n    %{\n      ips:             %Benchee.Conversion.Unit{\n                         label: \"K\",\n                         long: \"Thousand\",\n                         magnitude: 1000,\n                         name: :thousand\n                       },\n      run_time:        %Benchee.Conversion.Unit{\n                         label: \"ms\",\n                         long: \"Milliseconds\",\n                         magnitude: 1_000_000,\n                         name: :millisecond\n                       },\n      memory:          %Benchee.Conversion.Unit{\n                         label: \"KB\",\n                         long: \"Kilobytes\",\n                         magnitude: 1024,\n                         name: :kilobyte\n                       },\n      reduction_count: %Benchee.Conversion.Unit{\n                         label: \"M\",\n                         long: \"Million\",\n                         magnitude: 1000000,\n                         name: :million\n                       }\n    }","ref":"Benchee.Conversion.html#units/2-examples"},{"type":"module","title":"Benchee.Conversion.Count","doc":"Unit scaling for counts, such that 1000000 can be converted to 1 Million.\n\nOnly Benchee plugins should use this code.","ref":"Benchee.Conversion.Count.html"},{"type":"function","title":"Benchee.Conversion.Count.base_unit/0","doc":"The raw count, unscaled.","ref":"Benchee.Conversion.Count.html#base_unit/0"},{"type":"function","title":"Examples - Benchee.Conversion.Count.base_unit/0","doc":"iex> base_unit().name\n    :one","ref":"Benchee.Conversion.Count.html#base_unit/0-examples"},{"type":"function","title":"Benchee.Conversion.Count.best/2","doc":"Finds the best unit for a list of counts. By default, chooses the most common\nunit. In case of tie, chooses the largest of the most common units.\n\nPass `[strategy: :smallest]` to always return the smallest unit in the list.\nPass `[strategy: :largest]` to always return the largest unit in the list.","ref":"Benchee.Conversion.Count.html#best/2"},{"type":"function","title":"Examples - Benchee.Conversion.Count.best/2","doc":"iex> best([23, 23_000, 34_000, 2_340_000]).name\n    :thousand\n\n    iex> best([23, 23_000, 34_000, 2_340_000, 3_450_000]).name\n    :million\n\n    iex> best([23, 23_000, 34_000, 2_340_000], strategy: :smallest).name\n    :one\n\n    iex> best([23, 23_000, 34_000, 2_340_000], strategy: :largest).name\n    :million","ref":"Benchee.Conversion.Count.html#best/2-examples"},{"type":"function","title":"Benchee.Conversion.Count.convert/2","doc":"Converts a value for a specified %Unit or unit atom and converts it to the equivalent of another unit of measure.","ref":"Benchee.Conversion.Count.html#convert/2"},{"type":"function","title":"Examples - Benchee.Conversion.Count.convert/2","doc":"iex> {value, unit} = convert({2500, :thousand}, :million)\n  iex> value\n  2.5\n  iex> unit.name\n  :million","ref":"Benchee.Conversion.Count.html#convert/2-examples"},{"type":"function","title":"Benchee.Conversion.Count.format/1","doc":"Formats a number as a string, with a unit label.\n\nTo specify the unit, pass a tuple of `{value, unit_atom}` like `{1_234, :million}`","ref":"Benchee.Conversion.Count.html#format/1"},{"type":"function","title":"Examples - Benchee.Conversion.Count.format/1","doc":"iex> format(45_678.9)\n    \"45.68 K\"\n\n    iex> format(45.6789)\n    \"45.68\"\n\n    iex> format({45.6789, :thousand})\n    \"45.68 K\"\n\n    iex> format({45.6789, %Benchee.Conversion.Unit{long: \"Thousand\", magnitude: \"1_000\", label: \"K\"}})\n    \"45.68 K\"","ref":"Benchee.Conversion.Count.html#format/1-examples"},{"type":"function","title":"Benchee.Conversion.Count.format_human/1","doc":"Formats in a more \"human\" way separating by units.","ref":"Benchee.Conversion.Count.html#format_human/1"},{"type":"function","title":"Examples - Benchee.Conversion.Count.format_human/1","doc":"iex> format_human(45_678.9)\n    \"45 K 678.90\"\n\n    iex> format_human(1_000_000)\n    \"1 M\"\n\n    iex> format_human(1_001_000)\n    \"1 M 1 K\"","ref":"Benchee.Conversion.Count.html#format_human/1-examples"},{"type":"function","title":"Benchee.Conversion.Count.scale/1","doc":"Scales a value representing a count in ones into a larger unit if appropriate","ref":"Benchee.Conversion.Count.html#scale/1"},{"type":"function","title":"Examples - Benchee.Conversion.Count.scale/1","doc":"iex> {value, unit} = scale(4_321.09)\n    iex> value\n    4.32109\n    iex> unit.name\n    :thousand\n\n    iex> {value, unit} = scale(0.0045)\n    iex> value\n    0.0045\n    iex> unit.name\n    :one","ref":"Benchee.Conversion.Count.html#scale/1-examples"},{"type":"function","title":"Benchee.Conversion.Count.scale/2","doc":"Scales a value representing a count in ones into a specified unit","ref":"Benchee.Conversion.Count.html#scale/2"},{"type":"function","title":"Examples - Benchee.Conversion.Count.scale/2","doc":"iex> scale(12345, :one)\n    12345.0\n\n    iex> scale(12345, :thousand)\n    12.345\n\n    iex> scale(12345, :billion)\n    1.2345e-5\n\n    iex> scale(12345, :million)\n    0.012345","ref":"Benchee.Conversion.Count.html#scale/2-examples"},{"type":"function","title":"Benchee.Conversion.Count.unit_for/1","doc":"Get a unit by its atom representation. If handed already a %Unit{} struct it\njust returns it.","ref":"Benchee.Conversion.Count.html#unit_for/1"},{"type":"function","title":"Examples - Benchee.Conversion.Count.unit_for/1","doc":"iex> unit_for :thousand\n    %Benchee.Conversion.Unit{\n      name:      :thousand,\n      magnitude: 1_000,\n      label:     \"K\",\n      long:      \"Thousand\"\n    }\n\n    iex> unit_for(%Benchee.Conversion.Unit{\n    ...>   name:      :thousand,\n    ...>   magnitude: 1_000,\n    ...>   label:     \"K\",\n    ...>   long:      \"Thousand\"\n    ...>})\n    %Benchee.Conversion.Unit{\n      name:      :thousand,\n      magnitude: 1_000,\n      label:     \"K\",\n      long:      \"Thousand\"\n    }","ref":"Benchee.Conversion.Count.html#unit_for/1-examples"},{"type":"function","title":"Benchee.Conversion.Count.units/0","doc":"","ref":"Benchee.Conversion.Count.html#units/0"},{"type":"type","title":"Benchee.Conversion.Count.unit_atoms/0","doc":"","ref":"Benchee.Conversion.Count.html#t:unit_atoms/0"},{"type":"type","title":"Benchee.Conversion.Count.units/0","doc":"","ref":"Benchee.Conversion.Count.html#t:units/0"},{"type":"module","title":"Benchee.Conversion.DeviationPercent","doc":"Helps with formatting for the standard deviation ratio converting it into the\nmore common percent form.\n\nOnly Benchee plugins should use this code.","ref":"Benchee.Conversion.DeviationPercent.html"},{"type":"function","title":"Benchee.Conversion.DeviationPercent.format/1","doc":"Formats the standard deviation ratio to an equivalent percent number including special signs.\n\nThe ± is an important part of it as it shows that the deviation might be up but also might be\ndown.","ref":"Benchee.Conversion.DeviationPercent.html#format/1"},{"type":"function","title":"Examples - Benchee.Conversion.DeviationPercent.format/1","doc":"iex> format(0.12345)\n    \"±12.35%\"\n\n    iex> format(1)\n    \"±100.00%\"","ref":"Benchee.Conversion.DeviationPercent.html#format/1-examples"},{"type":"function","title":"Benchee.Conversion.DeviationPercent.format_human/1","doc":"Formats standard deviation percent, same as `format/1`.\n\nImplemented for consistency.","ref":"Benchee.Conversion.DeviationPercent.html#format_human/1"},{"type":"function","title":"Examples - Benchee.Conversion.DeviationPercent.format_human/1","doc":"iex> format_human(0.1)\n    \"±10.00%\"","ref":"Benchee.Conversion.DeviationPercent.html#format_human/1-examples"},{"type":"module","title":"Benchee.Conversion.Duration","doc":"Unit scaling for duration converting from microseconds to minutes and others.\n\nOnly Benchee plugins should use this code.","ref":"Benchee.Conversion.Duration.html"},{"type":"function","title":"Benchee.Conversion.Duration.base_unit/0","doc":"The most basic unit in which measurements occur.","ref":"Benchee.Conversion.Duration.html#base_unit/0"},{"type":"function","title":"Examples - Benchee.Conversion.Duration.base_unit/0","doc":"iex> base_unit().name\n    :nanosecond","ref":"Benchee.Conversion.Duration.html#base_unit/0-examples"},{"type":"function","title":"Benchee.Conversion.Duration.best/2","doc":"Finds the best unit for a list of durations. By default, chooses the most common\nunit. In case of tie, chooses the largest of the most common units.\n\nPass `[strategy: :smallest]` to always return the smallest unit in the list.\nPass `[strategy: :largest]` to always return the largest unit in the list.","ref":"Benchee.Conversion.Duration.html#best/2"},{"type":"function","title":"Examples - Benchee.Conversion.Duration.best/2","doc":"iex> best([23, 23_000, 34_000, 2_340_000]).name\n    :microsecond\n\n    iex> best([23, 23_000, 34_000_000, 2_340_000_000, 3_450_000_000]).name\n    :second\n\n    iex> best([23, 23_000, 34_000, 2_340_000], strategy: :smallest).name\n    :nanosecond\n\n    iex> best([23, 23_000, 34_000, 2_340_000_000], strategy: :largest).name\n    :second","ref":"Benchee.Conversion.Duration.html#best/2-examples"},{"type":"function","title":"Benchee.Conversion.Duration.convert/2","doc":"Converts a value for a specified %Unit or unit atom and converts it to the equivalent of another unit of measure.","ref":"Benchee.Conversion.Duration.html#convert/2"},{"type":"function","title":"Examples - Benchee.Conversion.Duration.convert/2","doc":"iex> {value, unit} = convert({90, :minute}, :hour)\n  iex> value\n  1.5\n  iex> unit.name\n  :hour","ref":"Benchee.Conversion.Duration.html#convert/2-examples"},{"type":"function","title":"Benchee.Conversion.Duration.convert_value/2","doc":"Converts a value of the given unit into the desired unit, returning only the value not the unit.","ref":"Benchee.Conversion.Duration.html#convert_value/2"},{"type":"function","title":"Examples - Benchee.Conversion.Duration.convert_value/2","doc":"iex> convert_value({1.234, :second}, :microsecond)\n    1_234_000.0\n\n    iex> convert_value({1.234, :minute}, :microsecond)\n    7.404e7\n\n    iex> microseconds = convert_value({1.234, :minute}, :microsecond)\n    iex> {value, _} = convert({microseconds, :microsecond}, :minute)\n    iex> value\n    1.234","ref":"Benchee.Conversion.Duration.html#convert_value/2-examples"},{"type":"function","title":"Benchee.Conversion.Duration.format/1","doc":"Formats a number as a string, with a unit label. To specify the unit, pass\na tuple of `{value, unit_atom}` like `{1_234, :second}`.","ref":"Benchee.Conversion.Duration.html#format/1"},{"type":"function","title":"Examples - Benchee.Conversion.Duration.format/1","doc":"iex> format(45_678.9)\n    \"45.68 μs\"\n\n    iex> format(45.6789)\n    \"45.68 ns\"\n\n    iex> format({45.6789, :millisecond})\n    \"45.68 ms\"\n\n    iex> format {45.6789,\n    ...>   %Benchee.Conversion.Unit{\n    ...>     long: \"Milliseconds\", magnitude: 1000, label: \"ms\"}\n    ...>   }\n    \"45.68 ms\"","ref":"Benchee.Conversion.Duration.html#format/1-examples"},{"type":"function","title":"Benchee.Conversion.Duration.format_human/1","doc":"Formats in a more \"human\" way - 1h 30min instead of 1.5h.","ref":"Benchee.Conversion.Duration.html#format_human/1"},{"type":"function","title":"Examples - Benchee.Conversion.Duration.format_human/1","doc":"iex> format_human(5_400_000_000_000)\n    \"1 h 30 min\"\n\n    iex> format_human(12.5)\n    \"12.50 ns\"\n\n    iex> format_human(1000.555)\n    \"1 μs 0.55 ns\"\n\n    iex> format_human(3_660_001_001_000)\n    \"1 h 1 min 1 ms 1 μs\"\n\n    iex> format_human(0)\n    \"0 ns\"\n\n    iex> format_human(2 * 1000 * 1000 * 1000)\n    \"2 s\"","ref":"Benchee.Conversion.Duration.html#format_human/1-examples"},{"type":"function","title":"Benchee.Conversion.Duration.scale/1","doc":"Scales a duration value in nanoseconds into a larger unit if appropriate","ref":"Benchee.Conversion.Duration.html#scale/1"},{"type":"function","title":"Examples - Benchee.Conversion.Duration.scale/1","doc":"iex> {value, unit} = scale(1)\n    iex> value\n    1.0\n    iex> unit.name\n    :nanosecond\n\n    iex> {value, unit} = scale(1_234)\n    iex> value\n    1.234\n    iex> unit.name\n    :microsecond\n\n    iex> {value, unit} = scale(11_234_567_890_123)\n    iex> value\n    3.1207133028119443\n    iex> unit.name\n    :hour","ref":"Benchee.Conversion.Duration.html#scale/1-examples"},{"type":"function","title":"Benchee.Conversion.Duration.scale/2","doc":"Scales a duration value in nanoseconds into a value in the specified unit","ref":"Benchee.Conversion.Duration.html#scale/2"},{"type":"function","title":"Examples - Benchee.Conversion.Duration.scale/2","doc":"iex> scale(12345, :nanosecond)\n    12345.0\n\n    iex> scale(12345, :microsecond)\n    12.345\n\n    iex> scale(12345, :minute)\n    2.0575e-7","ref":"Benchee.Conversion.Duration.html#scale/2-examples"},{"type":"function","title":"Benchee.Conversion.Duration.unit_for/1","doc":"Get a unit by its atom representation. If handed already a %Unit{} struct it\njust returns it.","ref":"Benchee.Conversion.Duration.html#unit_for/1"},{"type":"function","title":"Examples - Benchee.Conversion.Duration.unit_for/1","doc":"iex> unit_for :hour\n    %Benchee.Conversion.Unit{\n      name:      :hour,\n      magnitude: 3_600_000_000_000,\n      label:     \"h\",\n      long:      \"Hours\"\n    }\n\n    iex> unit_for(%Benchee.Conversion.Unit{\n    ...>   name:      :hour,\n    ...>   magnitude: 3_600_000_000_000,\n    ...>   label:     \"h\",\n    ...>   long:      \"Hours\"\n    ...>})\n    %Benchee.Conversion.Unit{\n      name:      :hour,\n      magnitude: 3_600_000_000_000,\n      label:     \"h\",\n      long:      \"Hours\"\n    }","ref":"Benchee.Conversion.Duration.html#unit_for/1-examples"},{"type":"function","title":"Benchee.Conversion.Duration.units/0","doc":"","ref":"Benchee.Conversion.Duration.html#units/0"},{"type":"behaviour","title":"Benchee.Conversion.Format","doc":"Functions for formatting values and their unit labels. Different domains\nhandle this task differently, for example durations and counts.\n\nSee `Benchee.Conversion.Count` and `Benchee.Conversion.Duration` for examples.","ref":"Benchee.Conversion.Format.html"},{"type":"function","title":"Benchee.Conversion.Format.format/1","doc":"Formats a unit value in the domain described by `module`. The module should\nprovide a `units/0` function that returns a Map like\n\n    %{ :unit_name => %Benchee.Conversion.Unit{ ... } }\n\nAdditionally, `module` may specify a `separator/0` function, which provides a\ncustom separator string that will appear between the value and label in the\nformatted output. If no `separator/0` function exists, the default separator\n(a single space) will be used.\n\n    iex> format({1.0, :kilobyte}, Benchee.Conversion.Memory)\n    \"1 KB\"","ref":"Benchee.Conversion.Format.html#format/1"},{"type":"callback","title":"Benchee.Conversion.Format.format/1","doc":"Formats a number as a string, with a unit label. See `Benchee.Conversion.Count`\nand `Benchee.Conversion.Duration` for examples","ref":"Benchee.Conversion.Format.html#c:format/1"},{"type":"function","title":"Benchee.Conversion.Format.format/2","doc":"","ref":"Benchee.Conversion.Format.html#format/2"},{"type":"function","title":"Benchee.Conversion.Format.format/3","doc":"Formats a unit value with specified label and separator","ref":"Benchee.Conversion.Format.html#format/3"},{"type":"callback","title":"Benchee.Conversion.Format.format_human/1","doc":"Formats in a more \"human\" way, one biggest unit at a time.\n\nSo instead of 1.5h it says 1h 30min","ref":"Benchee.Conversion.Format.html#c:format_human/1"},{"type":"function","title":"Benchee.Conversion.Format.format_human/2","doc":"Human friendly duration format for time as a string.\n\nThe output is a sequence of values and unit labels separated by a space.\nOnly units whose value is non-zero are included in the output.\nThe passed number is duration in the base unit - nanoseconds.","ref":"Benchee.Conversion.Format.html#format_human/2"},{"type":"module","title":"Benchee.Conversion.Memory","doc":"Unit scaling for memory converting from bytes to kilobytes and others.\n\nOnly Benchee plugins should use this code.","ref":"Benchee.Conversion.Memory.html"},{"type":"function","title":"Benchee.Conversion.Memory.base_unit/0","doc":"The most basic unit in which memory occur, byte.","ref":"Benchee.Conversion.Memory.html#base_unit/0"},{"type":"function","title":"Examples - Benchee.Conversion.Memory.base_unit/0","doc":"iex> base_unit().name\n    :byte","ref":"Benchee.Conversion.Memory.html#base_unit/0-examples"},{"type":"function","title":"Benchee.Conversion.Memory.best/2","doc":"Finds the best unit for a list of memory units. By default, chooses the most common\nunit. In case of tie, chooses the largest of the most common units.\n\nPass `[strategy: :smallest]` to always return the smallest unit in the list.\nPass `[strategy: :largest]` to always return the largest unit in the list.\nPass `[strategy: :best]` to always return the most frequent unit in the list.\nPass `[strategy: :none]` to always return :byte.","ref":"Benchee.Conversion.Memory.html#best/2"},{"type":"function","title":"Examples - Benchee.Conversion.Memory.best/2","doc":"iex> best([23, 23_000, 34_000, 2_340_000]).name\n    :kilobyte\n\n    iex> best([23, 23_000, 34_000, 2_340_000, 3_450_000]).name\n    :megabyte\n\n    iex> best([23, 23_000, 34_000, 2_340_000], strategy: :smallest).name\n    :byte\n\n    iex> best([23, 23_000, 34_000, 2_340_000], strategy: :largest).name\n    :megabyte","ref":"Benchee.Conversion.Memory.html#best/2-examples"},{"type":"function","title":"Benchee.Conversion.Memory.convert/2","doc":"Converts a value for a specified %Unit or unit atom and converts it to the equivalent of another unit of measure.","ref":"Benchee.Conversion.Memory.html#convert/2"},{"type":"function","title":"Examples - Benchee.Conversion.Memory.convert/2","doc":"iex> {value, unit} = convert({1024, :kilobyte}, :megabyte)\n  iex> value\n  1.0\n  iex> unit.name\n  :megabyte\n\n  iex> current_unit = unit_for :kilobyte\n  iex> {value, unit} = convert({1024, current_unit}, :megabyte)\n  iex> value\n  1.0\n  iex> unit.name\n  :megabyte","ref":"Benchee.Conversion.Memory.html#convert/2-examples"},{"type":"function","title":"Benchee.Conversion.Memory.format/1","doc":"Formats a memory as a string, with a unit label.\n\nTo specify the unit, pass a tuple of `{value, unit_atom}` like `{1_234, :kilobyte}`.","ref":"Benchee.Conversion.Memory.html#format/1"},{"type":"function","title":"Examples - Benchee.Conversion.Memory.format/1","doc":"iex> format(45_678.9)\n    \"44.61 KB\"\n\n    iex> format(45.6789)\n    \"45.68 B\"\n\n    iex> format({45.6789, :kilobyte})\n    \"45.68 KB\"\n\n    iex> format {45.6789,\n    ...>   %Benchee.Conversion.Unit{\n    ...>     long: \"Kilobytes\", magnitude: 1024, label: \"KB\"}\n    ...>   }\n    \"45.68 KB\"","ref":"Benchee.Conversion.Memory.html#format/1-examples"},{"type":"function","title":"Benchee.Conversion.Memory.format_human/1","doc":"Formats in a more human way, where multiple units are used.","ref":"Benchee.Conversion.Memory.html#format_human/1"},{"type":"function","title":"Examples - Benchee.Conversion.Memory.format_human/1","doc":"iex> format_human(45_678.9)\n    \"44 KB 622.90 B\"\n\n    iex> format_human(1024 * 1024 * 1024)\n    \"1 GB\"","ref":"Benchee.Conversion.Memory.html#format_human/1-examples"},{"type":"function","title":"Benchee.Conversion.Memory.scale/1","doc":"Scales a memory value in bytes into a larger unit if appropriate","ref":"Benchee.Conversion.Memory.html#scale/1"},{"type":"function","title":"Examples - Benchee.Conversion.Memory.scale/1","doc":"iex> {value, unit} = scale(1)\n  iex> value\n  1.0\n  iex> unit.name\n  :byte\n\n  iex> {value, unit} = scale(1_234)\n  iex> value\n  1.205078125\n  iex> unit.name\n  :kilobyte\n\n  iex> {value, unit} = scale(11_234_567_890.123)\n  iex> value\n  10.463006692121736\n  iex> unit.name\n  :gigabyte\n\n  iex> {value, unit} = scale(1_111_234_567_890.123)\n  iex> value\n  1.0106619519229962\n  iex> unit.name\n  :terabyte","ref":"Benchee.Conversion.Memory.html#scale/1-examples"},{"type":"function","title":"Benchee.Conversion.Memory.scale/2","doc":"Scales a memory value in bytes into a value in the specified unit","ref":"Benchee.Conversion.Memory.html#scale/2"},{"type":"function","title":"Examples - Benchee.Conversion.Memory.scale/2","doc":"iex> scale(12345, :kilobyte)\n    12.0556640625\n\n    iex> scale(12345, :megabyte)\n    0.011773109436035156\n\n    iex> scale(123_456_789, :gigabyte)\n    0.11497809458523989","ref":"Benchee.Conversion.Memory.html#scale/2-examples"},{"type":"function","title":"Benchee.Conversion.Memory.unit_for/1","doc":"Get a unit by its atom representation. If handed already a %Unit{} struct it\njust returns it.","ref":"Benchee.Conversion.Memory.html#unit_for/1"},{"type":"function","title":"Examples - Benchee.Conversion.Memory.unit_for/1","doc":"iex> unit_for :gigabyte\n    %Benchee.Conversion.Unit{\n        name:      :gigabyte,\n        magnitude: 1_073_741_824,\n        label:     \"GB\",\n        long:      \"Gigabytes\"\n    }\n\n    iex> unit_for(%Benchee.Conversion.Unit{\n    ...>   name:      :gigabyte,\n    ...>   magnitude: 1_073_741_824,\n    ...>   label:     \"GB\",\n    ...>   long:      \"Gigabytes\"\n    ...>})\n    %Benchee.Conversion.Unit{\n        name:      :gigabyte,\n        magnitude: 1_073_741_824,\n        label:     \"GB\",\n        long:      \"Gigabytes\"\n    }","ref":"Benchee.Conversion.Memory.html#unit_for/1-examples"},{"type":"function","title":"Benchee.Conversion.Memory.units/0","doc":"","ref":"Benchee.Conversion.Memory.html#units/0"},{"type":"type","title":"Benchee.Conversion.Memory.any_unit/0","doc":"","ref":"Benchee.Conversion.Memory.html#t:any_unit/0"},{"type":"type","title":"Benchee.Conversion.Memory.unit_atom/0","doc":"","ref":"Benchee.Conversion.Memory.html#t:unit_atom/0"},{"type":"behaviour","title":"Benchee.Conversion.Scale","doc":"Functions for scaling values to other units. Different domains handle\nthis task differently, for example durations and counts.\n\nSee `Benchee.Conversion.Count` and `Benchee.Conversion.Duration` for examples","ref":"Benchee.Conversion.Scale.html"},{"type":"callback","title":"Benchee.Conversion.Scale.base_unit/0","doc":"Returns the base_unit in which Benchee takes its measurements, which in\ngeneral is the smallest supported unit.","ref":"Benchee.Conversion.Scale.html#c:base_unit/0"},{"type":"callback","title":"Benchee.Conversion.Scale.best/2","doc":"Finds the best fit unit for a list of numbers in a domain's base unit.\n\"Best fit\" is the most common unit, or (in case of tie) the largest of the\nmost common units.","ref":"Benchee.Conversion.Scale.html#c:best/2"},{"type":"function","title":"Benchee.Conversion.Scale.best_unit/3","doc":"Given a `list` of number values and a `module` describing the domain of the\nvalues (e.g. Duration, Count), finds the \"best fit\" unit for the list as a\nwhole.\n\nThe best fit unit for a given value is the smallest unit in the domain for\nwhich the scaled value is at least 1. For example, the best fit unit for a\ncount of 1_000_000 would be `:million`.\n\nThe best fit unit for the list as a whole depends on the `:strategy` passed\nin `opts`:\n\n* `:best`     - the most frequent best fit unit. In case of tie, the\nlargest of the most frequent units\n* `:largest`  - the largest best fit unit\n* `:smallest` - the smallest best fit unit\n* `:none`     - the domain's base (unscaled) unit","ref":"Benchee.Conversion.Scale.html#best_unit/3"},{"type":"function","title":"Examples - Benchee.Conversion.Scale.best_unit/3","doc":"iex> list = [1, 101, 1_001, 10_001, 100_001, 1_000_001]\n    iex> best_unit(list, Benchee.Conversion.Count, strategy: :best).name\n    :thousand\n\n    iex> list = [1, 101, 1_001, 10_001, 100_001, 1_000_001]\n    iex> best_unit(list, Benchee.Conversion.Count, strategy: :smallest).name\n    :one\n\n    iex> list = [1, 101, 1_001, 10_001, 100_001, 1_000_001]\n    iex> best_unit(list, Benchee.Conversion.Count, strategy: :largest).name\n    :million\n\n    iex> list = []\n    iex> best_unit(list, Benchee.Conversion.Count, strategy: :best).name\n    :one\n\n    iex> list = [nil]\n    iex> best_unit(list, Benchee.Conversion.Count, strategy: :best).name\n    :one\n\n    iex> list = [nil, nil, nil, nil]\n    iex> best_unit(list, Benchee.Conversion.Count, strategy: :best).name\n    :one\n\n    iex> list = [nil, nil, nil, nil, 2_000]\n    iex> best_unit(list, Benchee.Conversion.Count, strategy: :best).name\n    :thousand","ref":"Benchee.Conversion.Scale.html#best_unit/3-examples"},{"type":"callback","title":"Benchee.Conversion.Scale.convert/2","doc":"Takes a tuple of a number and a unit and a unit to be converted to, returning\nthe the number scaled to the new unit and the new unit.","ref":"Benchee.Conversion.Scale.html#c:convert/2"},{"type":"function","title":"Benchee.Conversion.Scale.convert/3","doc":"Used internally to implement scaling in the modules without duplication.","ref":"Benchee.Conversion.Scale.html#convert/3"},{"type":"callback","title":"Benchee.Conversion.Scale.scale/1","doc":"Scales a number in a domain's base unit to an equivalent value in the best\nfit unit. Results are a `{number, unit}` tuple. See `Benchee.Conversion.Count` and\n`Benchee.Conversion.Duration` for examples.","ref":"Benchee.Conversion.Scale.html#c:scale/1"},{"type":"function","title":"Benchee.Conversion.Scale.scale/2","doc":"Used internally for scaling but only supports scaling with actual units.","ref":"Benchee.Conversion.Scale.html#scale/2"},{"type":"function","title":"Examples - Benchee.Conversion.Scale.scale/2","doc":"iex> unit = %Benchee.Conversion.Unit{magnitude: 1000}\n    iex> scale 12345, unit\n    12.345","ref":"Benchee.Conversion.Scale.html#scale/2-examples"},{"type":"callback","title":"Benchee.Conversion.Scale.scale/2","doc":"Scales a number in a domain's base unit to an equivalent value in the\nspecified unit.\nSee `Benchee.Conversion.Count` and `Benchee.Conversion.Duration` for examples.","ref":"Benchee.Conversion.Scale.html#c:scale/2"},{"type":"function","title":"Benchee.Conversion.Scale.scale/3","doc":"Used internally by implemented units to handle their scaling with units and\nwithout.","ref":"Benchee.Conversion.Scale.html#scale/3"},{"type":"function","title":"Examples - Benchee.Conversion.Scale.scale/3","doc":"iex> scale(12345, :thousand, Benchee.Conversion.Count)\n    12.345","ref":"Benchee.Conversion.Scale.html#scale/3-examples"},{"type":"callback","title":"Benchee.Conversion.Scale.unit_for/1","doc":"Given the atom representation of a unit (`:hour`) return the appropriate\n`Benchee.Conversion.Unit` struct.","ref":"Benchee.Conversion.Scale.html#c:unit_for/1"},{"type":"function","title":"Benchee.Conversion.Scale.unit_for/2","doc":"Lookup a unit by its `atom` presentation for the representation of supported\nunits. Used by `Benchee.Conversion.Duration` and `Benchee.Conversion.Count`.","ref":"Benchee.Conversion.Scale.html#unit_for/2"},{"type":"callback","title":"Benchee.Conversion.Scale.units/0","doc":"List of all the units supported by this type.","ref":"Benchee.Conversion.Scale.html#c:units/0"},{"type":"type","title":"Benchee.Conversion.Scale.any_unit/0","doc":"","ref":"Benchee.Conversion.Scale.html#t:any_unit/0"},{"type":"type","title":"Benchee.Conversion.Scale.scaled_number/0","doc":"","ref":"Benchee.Conversion.Scale.html#t:scaled_number/0"},{"type":"type","title":"Benchee.Conversion.Scale.scaling_strategy/0","doc":"","ref":"Benchee.Conversion.Scale.html#t:scaling_strategy/0"},{"type":"type","title":"Benchee.Conversion.Scale.unit/0","doc":"","ref":"Benchee.Conversion.Scale.html#t:unit/0"},{"type":"type","title":"Benchee.Conversion.Scale.unit_atom/0","doc":"","ref":"Benchee.Conversion.Scale.html#t:unit_atom/0"},{"type":"module","title":"Benchee.Conversion.Unit","doc":"A representation of the different units used in `Benchee.Conversion.Format`\nand `Benchee.Conversion.Scale` as well as the modules implementing these\nbehaviours.\n\nA unit is characterized by:\n\n* name - an atom representation of the unit for easy access (`:microseconds`,\n`thousand`)\n* magnitude - compared to he base unit (the smallest unit) what's the factor\nyou had to multiply it by to get back to the base unit. E.g. the thousand\nunit has a magnitude of `1_000`.\n* label - a string that is used as a unit label (`\"K\"` for a thousand f.ex.)\n* long - a string giving the long version of the label (`\"Thousand\"`)","ref":"Benchee.Conversion.Unit.html"},{"type":"type","title":"Benchee.Conversion.Unit.t/0","doc":"","ref":"Benchee.Conversion.Unit.html#t:t/0"},{"type":"behaviour","title":"Benchee.Formatter","doc":"Defines a behaviour for formatters in Benchee, and functions to work with these.\n\nWhen implementing a Benchee formatter as a behaviour please adopt this\nbehaviour, as it helps with uniformity and also allows at least the `.format`\nfunction of formatters to be run in parallel.\n\nThe module itself then has functions to deal with formatters defined in this way\nallowing for parallel output through `output/1` or just output a single formatter\nthrough `output/3`.","ref":"Benchee.Formatter.html"},{"type":"callback","title":"Benchee.Formatter.format/2","doc":"Takes a suite and returns a representation `write/2` can use.\n\nTakes the suite and returns whatever representation the formatter wants to use\nto output that information. It is important that this function **needs to be\npure** (aka have no side effects) as Benchee will run `format/1` functions\nof multiple formatters in parallel. The result will then be passed to\n`write/2`.\n\n**Note:** Due to memory consumption issues in benchmarks with big inputs, the suite\npassed to the formatters **is missing anything referencing big input data** to avoid\nhuge memory consumption and run time. Namely this constitutes:\n* `Benchee.Scenario` will have `function` and `input` set to `nil`\n* `Benchee.Configuration` will have `inputs`, but it won't have values only the names,\nit may be removed in the future please use `input_names` instead if needed (or\n`input_name` of `Benchee.Scenario`)\n\nTechnically speaking this \"scrubbing\" of `Benchee.Suite` only occurs when formatters\nare run in parallel, you still shouldn't rely on those values (and they should not\nbe needed). If you do need them for some reason, please get in touch/open an issue.","ref":"Benchee.Formatter.html#c:format/2"},{"type":"function","title":"Benchee.Formatter.output/1","doc":"Format and output all configured formatters and formatting functions.\n\nExpects a suite that already has been run through all previous functions so has the aggregated\nstatistics etc. that the formatters rely on.\n\nWorks by invoking the `format/2` and `write/2` functions defined in this module. The `format/2`\nfunctions are actually called in parallel (as they should be pure) - due to potential\ninterference the `write/2` functions are called serial.\n\nAlso handles pure functions that will then be called with the suite.\n\nYou can't rely on the formatters being called in pre determined order.","ref":"Benchee.Formatter.html#output/1"},{"type":"function","title":"Benchee.Formatter.output/3","doc":"Output a suite with a given formatter and options.\n\nReplacement for the old `MyFormatter.output/1` - calls `format/2` and `write/2` one after another\nto create the output defined by the given formatter module. For the given options please refer\nto the documentation of the formatters you use.","ref":"Benchee.Formatter.html#output/3"},{"type":"callback","title":"Benchee.Formatter.write/2","doc":"Takes the return value of `format/1` and then performs some I/O for the user\nto actually see the formatted data (UI, File IO, HTTP, ...)","ref":"Benchee.Formatter.html#c:write/2"},{"type":"type","title":"Benchee.Formatter.options/0","doc":"Options given to formatters, entirely defined by formatter authors.","ref":"Benchee.Formatter.html#t:options/0"},{"type":"type","title":"Benchee.Formatter.scrubbed_suite/0","doc":"A suite scrubbed of heavy data.\n\nType to bring awareness to the fact that `format/2` doesn't have access to\n_all_ data in `Benchee.Suite` - please read the docs for `format/2` to learn\nmore.","ref":"Benchee.Formatter.html#t:scrubbed_suite/0"},{"type":"module","title":"Benchee.Formatters.Console","doc":"Formatter to print out the results of benchmarking suite to the console.\n\nExample:\n\n    Name                  ips        average  deviation         median         99th %\n    flat_map           2.40 K      417.00 μs     ±9.40%      411.45 μs      715.21 μs\n    map.flatten        1.24 K      806.89 μs    ±16.62%      768.02 μs     1170.67 μs\n\n    Comparison:\n    flat_map           2.40 K\n    map.flatten        1.24 K - 1.93x slower\n\n    Memory usage statistics:\n\n    Name           Memory usage\n    flat_map          624.97 KB\n    map.flatten       781.25 KB - 1.25x memory usage\n\n    **All measurements for memory usage were the same**\n\n    Reduction count statistics:\n\n    Name              average  deviation      median      99th %\n    flat_map           417.00      ±9.40      411.45      715.21\n    map.flatten        806.89     ±16.62      768.02     1170.67\n\n    Comparison:\n    flat_map           417.00\n    map.flatten        806.89 - 1.93x more reductions","ref":"Benchee.Formatters.Console.html"},{"type":"function","title":"Benchee.Formatters.Console.format/2","doc":"Formats the benchmark statistics to a report suitable for output on the CLI.\n\nReturns a list of lists, where each list element is a group belonging to one\nspecific input. So if there only was one (or no) input given through `:inputs`\nthen there's just one list inside.","ref":"Benchee.Formatters.Console.html#format/2"},{"type":"function","title":"Examples - Benchee.Formatters.Console.format/2","doc":"```\niex> scenarios = [\n...>   %Benchee.Scenario{\n...>     name: \"My Job\", input_name: \"My input\", run_time_data: %Benchee.CollectionData{\n...>       statistics: %Benchee.Statistics{\n...>         average: 200.0,\n...>         ips: 5000.0,\n...>         std_dev_ratio: 0.1,\n...>         median: 190.0,\n...>         percentiles: %{99 => 300.1},\n...>         sample_size: 200\n...>       }\n...>     },\n...>     memory_usage_data: %Benchee.CollectionData{statistics: %Benchee.Statistics{}}\n...>   },\n...>   %Benchee.Scenario{\n...>     name: \"Job 2\", input_name: \"My input\", run_time_data: %Benchee.CollectionData{\n...>       statistics: %Benchee.Statistics{\n...>         average: 400.0,\n...>         ips: 2500.0,\n...>         std_dev_ratio: 0.2,\n...>         median: 390.0,\n...>         percentiles: %{99 => 500.1},\n...>         sample_size: 200\n...>       }\n...>     },\n...>     memory_usage_data: %Benchee.CollectionData{statistics: %Benchee.Statistics{}}\n...>   }\n...> ]\niex> suite = %Benchee.Suite{\n...>   scenarios: scenarios,\n...>   configuration: %Benchee.Configuration{\n...>     unit_scaling: :best,\n...>   }\n...> }\niex> format(suite, %{comparison: false, extended_statistics: false})\n[[\"\n###","ref":"Benchee.Formatters.Console.html#format/2-examples"},{"type":"function","title":"With input My input #####\", \" - Benchee.Formatters.Console.format/2","doc":"Name             ips        average  deviation         median         99th %\n\",\n\"My Job           5 K         200 ns    ±10.00%         190 ns      300.10 ns\n\",\n\"Job 2         2.50 K         400 ns    ±20.00%         390 ns      500.10 ns\n\"]]\n\n```","ref":"Benchee.Formatters.Console.html#format/2-with-input-my-input"},{"type":"function","title":"Benchee.Formatters.Console.write/2","doc":"Takes the output of `format/1` and writes that to the console.","ref":"Benchee.Formatters.Console.html#write/2"},{"type":"module","title":"Benchee.Formatters.TaggedSave","doc":"Store the whole suite in the Erlang `ExternalTermFormat` while tagging the\nscenarios of the current run with a specified tag - can be used for storing\nand later loading the results of previous runs with `Benchee.ScenarioLoader`.\n\nAutomatically configured as the last formatter to run when specifying the\n`save` option in the configuration - see `Benchee.Configuration`.","ref":"Benchee.Formatters.TaggedSave.html"},{"type":"function","title":"Benchee.Formatters.TaggedSave.format/2","doc":"Tags all scenario with the desired tag and returns it in term_to_binary along with save path.","ref":"Benchee.Formatters.TaggedSave.html#format/2"},{"type":"function","title":"Benchee.Formatters.TaggedSave.write/2","doc":"Writes the binary returned by `format/2` to the indicated location, telling you where that is.","ref":"Benchee.Formatters.TaggedSave.html#write/2"},{"type":"module","title":"Benchee.Profile","doc":"Profiles each scenario after benchmarking them if the `profile_after` option is either set to:\n  * `true`,\n  * a valid `profiler`,\n  * a tuple of a valid `profiler` and a list of options to pass to it, e.g., `{:fprof, [sort: :own]}`.\n\nThe profiler that will be used is either the one set by the `profiler_after` option or, if set to `true`,\nthe default one (`:eprof`). It accepts however the following profilers:\n  * `:cprof` will profile with [`Mix.Task.Profile.Cprof`](https://hexdocs.pm/mix/Mix.Tasks.Profile.Cprof.html).\n  It provides information related to the number of function calls.\n  * `:eprof` will profile with [`Mix.Task.Profile.Eprof`](https://hexdocs.pm/mix/Mix.Tasks.Profile.Eprof.html).\n  It provides information related to the time spent on each function in regard to the total execution time.\n  * `:fprof` will profile with [`Mix.Task.Profile.Fprof`](https://hexdocs.pm/mix/Mix.Tasks.Profile.Cprof.html).\n  It provides information related to the time spent on each function, both the *total* time spent on it and the time spent on it,\n  *excluding* the time of called functions.","ref":"Benchee.Profile.html"},{"type":"function","title":"Benchee.Profile.builtin_profilers/0","doc":"List of supported builtin profilers as atoms.","ref":"Benchee.Profile.html#builtin_profilers/0"},{"type":"function","title":"Benchee.Profile.default_profiler/0","doc":"Returns the atom corresponding to the default profiler.","ref":"Benchee.Profile.html#default_profiler/0"},{"type":"function","title":"Benchee.Profile.profile/2","doc":"Runs for each scenario found in the suite the `profile/2` function from the given profiler.","ref":"Benchee.Profile.html#profile/2"},{"type":"module","title":"Benchee.RelativeStatistics","doc":"Statistics that are relative from one scenario to another.\n\nSuch as how much slower/faster something is or what the absolute difference is in the measured\nvalues.\nIs its own step because it has to be executed after scenarios have been loaded via\n`Benchee.ScenarioLoader` to include them in the calculation, while `Benchee.Statistics`\nhas to happen before they are loaded to avoid recalculating their statistics.","ref":"Benchee.RelativeStatistics.html"},{"type":"function","title":"Benchee.RelativeStatistics.relative_statistics/1","doc":"Calculate the statistics of scenarios relative to each other and sorts scenarios.\n\nSuch as `relative_more`, `relative_less` and `absolute_difference`,\nsee `t:Benchee.Statistics.t/0` for more.\n\nThe sorting of scenarios is important so that they always have the same order in\nall formatters. Scenarios are sorted first by run time average, then by memory average.","ref":"Benchee.RelativeStatistics.html#relative_statistics/1"},{"type":"module","title":"Benchee.Scenario","doc":"Core data structure representing one particular case (combination of function and input).\n\nRepresents the combination of a particular function to benchmark (also called \"job\" defined\nby `job_name` and `function`) in combination with a specific input (`input_name` and `input`).\nWhen no input is given, the combined value is representative of \"no input\".\n\nA scenario then further gathers all data collected for this particular combination during\n`Benchee.Benchmark.collect/3`, which are then used later in the process by `Benchee.Statistics`\nto compute the relevant statistics which are then also added to the scenario.\nIt is the home of the aggregated knowledge regarding this particular case/scenario.\n\n`name` is the name that should be used by formatters to display scenarios as\nit potentially includes the `tag` present when loading scenarios that were\nsaved before. See `display_name/1`.","ref":"Benchee.Scenario.html"},{"type":"function","title":"Benchee.Scenario.data_processed?/2","doc":"Returns `true` if data of the provided type has been fully procsessed, `false` otherwise.\n\nCurrent available types are `run_time` and `memory`. Reasons they might not have been processed\nyet are:\n* Suite wasn't configured to collect them at all\n* `Benchee.statistics/1` hasn't been called yet so that data was collected but statistics\n  aren't present yet","ref":"Benchee.Scenario.html#data_processed?/2"},{"type":"function","title":"Examples - Benchee.Scenario.data_processed?/2","doc":"iex> scenario = %Benchee.Scenario{run_time_data: %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 100}}}\n    iex> data_processed?(scenario, :run_time)\n    true\n\n    iex> scenario = %Benchee.Scenario{memory_usage_data: %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 1}}}\n    iex> data_processed?(scenario, :memory)\n    true\n\n    iex> scenario = %Benchee.Scenario{reductions_data: %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 1}}}\n    iex> data_processed?(scenario, :reductions)\n    true\n\n    iex> scenario = %Benchee.Scenario{memory_usage_data: %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 0}}}\n    iex> data_processed?(scenario, :memory)\n    false","ref":"Benchee.Scenario.html#data_processed?/2-examples"},{"type":"function","title":"Benchee.Scenario.display_name/1","doc":"Returns the correct name to display of the given scenario data.\n\nIn the normal case this is `job_name`, however when scenarios are loaded they\nare tagged and these tags should be shown for disambiguation.","ref":"Benchee.Scenario.html#display_name/1"},{"type":"function","title":"Examples - Benchee.Scenario.display_name/1","doc":"iex> display_name(%Benchee.Scenario{job_name: \"flat_map\"})\n    \"flat_map\"\n\n    iex> display_name(%Benchee.Scenario{job_name: \"flat_map\", tag: \"main\"})\n    \"flat_map (main)\"\n\n    iex> display_name(%{job_name: \"flat_map\"})\n    \"flat_map\"","ref":"Benchee.Scenario.html#display_name/1-examples"},{"type":"function","title":"Benchee.Scenario.measurement_data/2","doc":"Given the measurement type name given by `measurement_types/0`, get the associated data.\n\nRaises if no correct measurement type was specified.","ref":"Benchee.Scenario.html#measurement_data/2"},{"type":"function","title":"Examples - Benchee.Scenario.measurement_data/2","doc":"iex> scenario = %Benchee.Scenario{run_time_data: %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 1}}}\n    iex> measurement_data(scenario, :run_time)\n    %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 1}}\n\n    iex> scenario = %Benchee.Scenario{memory_usage_data: %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 2}}}\n    iex> measurement_data(scenario, :memory)\n    %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 2}}\n\n    iex> scenario = %Benchee.Scenario{reductions_data: %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 3}}}\n    iex> measurement_data(scenario, :reductions)\n    %Benchee.CollectionData{statistics: %Benchee.Statistics{sample_size: 3}}\n\n    iex> measurement_data(%Benchee.Scenario{}, :memory)\n    %Benchee.CollectionData{}\n\n    iex> measurement_data(%Benchee.Scenario{}, :invalid)\n    ** (FunctionClauseError) no function clause matching in Benchee.Scenario.measurement_data/2","ref":"Benchee.Scenario.html#measurement_data/2-examples"},{"type":"function","title":"Benchee.Scenario.measurement_types/0","doc":"Returns the different measurement types supported.","ref":"Benchee.Scenario.html#measurement_types/0"},{"type":"function","title":"Examples - Benchee.Scenario.measurement_types/0","doc":"iex> measurement_types()\n    [:run_time, :memory, :reductions]","ref":"Benchee.Scenario.html#measurement_types/0-examples"},{"type":"type","title":"Benchee.Scenario.benchmarking_function/0","doc":"The main function executed while benchmarking.\n\nNo arguments if no inputs are used, one argument if inputs are used.","ref":"Benchee.Scenario.html#t:benchmarking_function/0"},{"type":"type","title":"Benchee.Scenario.t/0","doc":"All the data collected for a scenario (combination of function and input)\n\nAmong all the data required to execute the scenario (function, input, all the hooks aka\nafter_*/before_*), data needed to display (name, job_name, input_name, tag) and of course\nrun_time_data and memory_data with all the samples and computed statistics.","ref":"Benchee.Scenario.html#t:t/0"},{"type":"type","title":"Benchee.Scenario.to_benchmark/0","doc":"What shall be benchmarked, mostly a function but can contain options.\n\nOptions are there for hooks (`after_each`, `before_each` etc.)","ref":"Benchee.Scenario.html#t:to_benchmark/0"},{"type":"module","title":"Benchee.ScenarioLoader","doc":"Load scenarios that were saved using the saved option to be included.\n\nUsually this is done right before the formatters run (that's when it happens\nin `Benchee.run/2`) as all measurements and statistics should be there.\nHowever, if you want to recompute statistics or others you can load them at\nany time. Just be aware that if you load them before `Benchee.collect/1` then\nthey'll be rerun and measurements overridden.","ref":"Benchee.ScenarioLoader.html"},{"type":"function","title":"Benchee.ScenarioLoader.load/1","doc":"Load the file(s) specified as `load_path` and add the scenarios to the list of the\ncurrent scenarios in the suite.","ref":"Benchee.ScenarioLoader.html#load/1"},{"type":"module","title":"Benchee.Statistics","doc":"Statistics related functionality that is meant to take the raw benchmark data\nand then compute statistics like the average and the standard deviation etc.\n\nSee `statistics/1` for a breakdown of the included statistics.","ref":"Benchee.Statistics.html"},{"type":"function","title":"Benchee.Statistics.statistics/2","doc":"Takes a suite with scenarios and their data samples, adds the statistics to the\nscenarios. For an overview of what the statistics mean see `t:t/0`.\n\nNote that this will also sort the scenarios fastest to slowest to ensure a consistent order\nof scenarios in all used formatters.","ref":"Benchee.Statistics.html#statistics/2"},{"type":"function","title":"Examples - Benchee.Statistics.statistics/2","doc":"iex> scenarios = [\n    ...>   %Benchee.Scenario{\n    ...>     job_name: \"My Job\",\n    ...>     run_time_data: %Benchee.CollectionData{\n    ...>       samples: [200, 400, 400, 400, 500, 500, 500, 700, 900]\n    ...>     },\n    ...>     memory_usage_data: %Benchee.CollectionData{\n    ...>       samples: [200, 400, 400, 400, 500, 500, 500, 700, 900]\n    ...>     },\n    ...>     input_name: \"Input\",\n    ...>     input: \"Input\"\n    ...>   }\n    ...> ]\n    iex> suite = %Benchee.Suite{scenarios: scenarios}\n    iex> statistics(suite, Benchee.Test.FakeProgressPrinter)\n    %Benchee.Suite{\n      scenarios: [\n        %Benchee.Scenario{\n          job_name: \"My Job\",\n          input_name: \"Input\",\n          input: \"Input\",\n          run_time_data: %Benchee.CollectionData{\n            samples: [200, 400, 400, 400, 500, 500, 500, 700, 900],\n            statistics: %Benchee.Statistics{\n              average:       500.0,\n              ips:           2000_000.0,\n              std_dev:       200.0,\n              std_dev_ratio: 0.4,\n              std_dev_ips:   800_000.0,\n              median:        500.0,\n              percentiles:   %{50 => 500.0, 99 => 900.0},\n              mode:          [500, 400],\n              minimum:       200,\n              maximum:       900,\n              sample_size:   9\n            }\n          },\n          memory_usage_data: %Benchee.CollectionData{\n            samples: [200, 400, 400, 400, 500, 500, 500, 700, 900],\n            statistics: %Benchee.Statistics{\n              average:       500.0,\n              ips:           nil,\n              std_dev:       200.0,\n              std_dev_ratio: 0.4,\n              std_dev_ips:   nil,\n              median:        500.0,\n              percentiles:   %{50 => 500.0, 99 => 900.0},\n              mode:          [500, 400],\n              minimum:       200,\n              maximum:       900,\n              sample_size:   9\n            }\n          }\n        }\n      ],\n      system: nil\n    }","ref":"Benchee.Statistics.html#statistics/2-examples"},{"type":"type","title":"Benchee.Statistics.mode/0","doc":"Careful with the mode, might be multiple values, one value or nothing.😱","ref":"Benchee.Statistics.html#t:mode/0"},{"type":"type","title":"Benchee.Statistics.samples/0","doc":"The samples a `Benchee.Collect` collected to compute statistics from.","ref":"Benchee.Statistics.html#t:samples/0"},{"type":"type","title":"Benchee.Statistics.t/0","doc":"All the statistics `statistics/1` computes from the samples.\n\nOverview of all the statistics Benchee currently provides:\n\n  * average       - average run time of the job in μs (the lower the better)\n  * ips           - iterations per second, how often can the given function be\n    executed within one second (the higher the better)\n  * std_dev       - standard deviation, a measurement how much results vary\n    (the higher the more the results vary)\n  * std_dev_ratio - standard deviation expressed as how much it is relative to\n    the average\n  * std_dev_ips   - the absolute standard deviation of iterations per second\n    (= ips * std_dev_ratio)\n  * median        - when all measured times are sorted, this is the middle\n    value (or average of the two middle values when the number of times is\n    even). More stable than the average and somewhat more likely to be a\n    typical value you see.\n  * percentiles   - a map of percentile ranks. These are the values below\n    which x% of the run times lie. For example, 99% of run times are shorter\n    than the 99th percentile (99th %) rank.\n    is a value for which 99% of the run times are shorter.\n  * mode          - the run time(s) that occur the most. Often one value, but\n    can be multiple values if they occur the same amount of times. If no value\n    occurs at least twice, this value will be nil.\n  * minimum       - the smallest sample measured for the scenario\n  * maximum       - the biggest sample measured for the scenario\n  * relative_more - relative to the reference (usually the fastest scenario) how much more\n    was the average of this scenario. E.g. for reference at 100, this scenario 200 then it\n    is 2.0.\n  * relative_less - relative to the reference (usually the fastest scenario) how much less\n    was the average of this scenario. E.g. for reference at 100, this scenario 200 then it\n    is 0.5.\n  * absolute_difference - relative to the reference (usually the fastest scenario) what is\n    the difference of the averages of the scenarios. e.g. for reference at 100, this\n    scenario 200 then it is 100.\n  * sample_size   - the number of run time measurements taken","ref":"Benchee.Statistics.html#t:t/0"},{"type":"module","title":"Benchee.Suite","doc":"Main Benchee data structure that aggregates the results from every step.\n\nDifferent layers of the benchmarking rely on different data being present\nhere. For instance for `Benchee.Statistics.statistics/1` to work the\n`run_time_data` key of each scenario needs to be filled with the samples\ncollected by `Benchee.Benchmark.collect/1`.\n\nFormatters can then use the data to display all of the results and the\nconfiguration.","ref":"Benchee.Suite.html"},{"type":"type","title":"Benchee.Suite.key/0","doc":"Valid key for either input or benchmarking job names.","ref":"Benchee.Suite.html#t:key/0"},{"type":"type","title":"Benchee.Suite.t/0","doc":"The main suite consisting of the configuration data, information about the system and most\nimportantly a list of `t:Benchee.Scenario.t/0`.","ref":"Benchee.Suite.html#t:t/0"},{"type":"module","title":"Benchee.System","doc":"Provides information about the system the benchmarks are run on.\n\nIncludes information such as elixir/erlang version, OS, CPU and memory.\n\nSo far supports/should work for Linux, MacOS, FreeBSD and Windows.","ref":"Benchee.System.html"},{"type":"function","title":"Benchee.System.system/1","doc":"Adds system information to the suite (currently elixir and erlang versions).","ref":"Benchee.System.html#system/1"},{"type":"type","title":"Benchee.System.t/0","doc":"","ref":"Benchee.System.html#t:t/0"},{"type":"module","title":"Benchee.Utility.FileCreation","doc":"Methods to easily handle file creation used in plugins.","ref":"Benchee.Utility.FileCreation.html"},{"type":"function","title":"Benchee.Utility.FileCreation.each/3","doc":"Open a file for write for all key/value pairs, interleaves the file name with\nthe key and calls the given function with file, content and filename.\n\nUses `interleave/2` to get the base filename and\nthe given keys together to one nice file name, then creates these files and\ncalls the function with the file and the content from the given map so that\ndata can be written to the file.\n\nIf a directory is specified, it creates the directory.\n\nExpects:\n\n* names_to_content - a map from input name to contents that should go into\nthe corresponding file\n* filename - the base file name as desired by the user\n* function - a function that is then called for every file with the associated\nfile content from the map, defaults to just writing the file content via\n`IO.write/2` and printing where it put the file.","ref":"Benchee.Utility.FileCreation.html#each/3"},{"type":"function","title":"Examples - Benchee.Utility.FileCreation.each/3","doc":"# Just writes the contents to a file\n    Benchee.Utility.FileCreation.each(%{\"My Input\" => \"_awesome html content_\"},\n      \"my.html\",\n      fn(file, content) -> IO.write(file, content) end)","ref":"Benchee.Utility.FileCreation.html#each/3-examples"},{"type":"function","title":"Benchee.Utility.FileCreation.ensure_directory_exists/1","doc":"Make sure the directory for the given file name exists.","ref":"Benchee.Utility.FileCreation.html#ensure_directory_exists/1"},{"type":"function","title":"Benchee.Utility.FileCreation.interleave/2","doc":"Gets file name/path, the input name and others together.\n\nTakes a list of values to interleave or just a single value.\nHandles the special no_input key to do no work at all.","ref":"Benchee.Utility.FileCreation.html#interleave/2"},{"type":"function","title":"Examples - Benchee.Utility.FileCreation.interleave/2","doc":"iex> interleave(\"abc.csv\", \"hello\")\n    \"abc_hello.csv\"\n\n    iex> interleave(\"abc.csv\", \"Big Input\")\n    \"abc_big_input.csv\"\n\n    iex> interleave(\"abc.csv\", \"String.length/1\")\n    \"abc_string_length_1.csv\"\n\n    iex> interleave(\"bench/abc.csv\", \"Big Input\")\n    \"bench/abc_big_input.csv\"\n\n    iex> interleave(\"bench/abc.csv\",\n    ...>   [\"Big Input\"])\n    \"bench/abc_big_input.csv\"\n\n    iex> interleave(\"abc.csv\", [])\n    \"abc.csv\"\n\n    iex> interleave(\"bench/abc.csv\",\n    ...>   [\"Big Input\", \"Comparison\"])\n    \"bench/abc_big_input_comparison.csv\"\n\n    iex> interleave(\"bench/A B C.csv\",\n    ...>   [\"Big Input\", \"Comparison\"])\n    \"bench/A B C_big_input_comparison.csv\"\n\n    iex> interleave(\"bench/abc.csv\",\n    ...>   [\"Big Input\", \"Comparison\", \"great Stuff\"])\n    \"bench/abc_big_input_comparison_great_stuff.csv\"\n\n    iex> marker = Benchee.Benchmark.no_input()\n    iex> interleave(\"abc.csv\", marker)\n    \"abc.csv\"\n    iex> interleave(\"abc.csv\", [marker])\n    \"abc.csv\"\n    iex> interleave(\"abc.csv\",\n    ...>   [marker, \"Comparison\"])\n    \"abc_comparison.csv\"\n    iex> interleave(\"abc.csv\",\n    ...>   [\"Something cool\", marker, \"Comparison\"])\n    \"abc_something_cool_comparison.csv\"","ref":"Benchee.Utility.FileCreation.html#interleave/2-examples"},{"type":"exception","title":"Benchee.Profile.Benchee.UnknownProfilerError","doc":"","ref":"Benchee.Profile.Benchee.UnknownProfilerError.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"1.3.0 (2023-12-22) - Changelog","doc":"A big swath of bug fixes and improvements. The highlights certainly are fixes and conveniences around saved benchmarks and loading them again via the new `Benchee.report/1`. The other big one is saving a lot of memory (and time!) when processing big inputs. Sadly the latter comes with some breaking changes for plugins, but they are well justified and shouldn't actually affect any plugin in practice.\n\nThere's also a **known issue** for elixir 1.14.0 to 1.16.0-rc.0 - [read up about it](https://github.com/bencheeorg/benchee#known-issues).\n\n#","ref":"changelog.html#1-3-0-2023-12-22"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* System information now includes whether or not the JIT is enabled ([erlang docs](https://www.erlang.org/doc/apps/erts/beamasm)).\n* Benchee now let's you know when it's calculating statistics or running the formatters. Helps when you wonder what's taking so long or blows up memory.\n* `Benchee.report/1` introduced if you just want to load saved benchmarks and report on them (---> run formatters).\n* Configuration times will now be displayed in a more human friendly format (1 min 12 s vs. 1.2 min). Thanks to [@drobnyd](https://github.com/drobnyd).\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Memory usage should be massively reduced when dealing with larger sets of data in inputs or benchmarking functions. They were needlessly sent to processes calculating statistics or formatters which could lead to memory blowing up.\n* Similarly, inputs and benchmarking functions will no longer be saved when using the `:save` option, this makes it immensely faster and depending on the size of the data a lot slower (I have an example with a factor 200x for the size). The side effect of this is that you also can't use `:load` and run the benchmarks saved again from just the file, this was never an intended use case though (as loading happens after benchmarking by default). You also still should have the benchmarking script so it's also not needed.\n* Fix a bug where relative statistics would always rely on the inputs provided in the config, which can break when you load saved benchmarks but don't specify the `inputs` again.\n\n#","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"Woopsie, didn't wanna do any of these in 1.x, sorry but there's good reason :( However, counting them as bugs.\n\n* Formatters have lost access to benchmarking functions and the inputs, this is to enable huge memory and run time savings when using a lot of data. I also believe they should not be needed for formatters, please get in touch if this is a problem so we can work it out. In detail this means:\n  * Each `Benchee.Scenario` struct in a formatter will have `:function` and `:input` set to `nil`\n  * The `inputs` list in `Configuration` retains the input names, but the values will be set to `:scrubbed_see_1_3_0_changelog`. It may be completely scrubbed in the future, use the newly introduced `input_names` instead if you need easy access to all the input names at once.\n  * Technically speaking formatters haven't generally lost access, only if they are processed in parallel - so not if it's the only formatter or if it's used via a function (`formatters: [fn suite -> MyFormatter.output(suite) end]`. Still, should not be used or relied upon.\n\n#","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* `jit_enabled?` is exposed as part of the `suite.system` struct\n* Yes, `Benchee.System` is now a struct so feel easier about relying on the fields\n* `Configuration` now has an `input_names` key that holds the name of all inputs, for the reasoning, see above.\n* The more human friendly formats are accessible via `Format.format_human/2` or `Duration.format_human/1` (& friends)","ref":"changelog.html#features-plugins"},{"type":"extras","title":"1.2.0 (2023-11-09) - Changelog","doc":"Long time, huh? 😉 I'm not gonna repeat all that, but I'm happy benchee is in a place where it just works and doesn't need too much support. Biggest feature here is the implementation of the `Table.Reader` protocol for a better Livebook experience.\n\n#","ref":"changelog.html#1-2-0-2023-11-09"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* Trying to benchmark evaluated functions will now result in a warning. Thanks [@BrooklinJazz](https://github.com/BrooklinJazz), [@czrpb](https://github.com/czrpb), [@aar2dee2](https://github.com/aar2dee2),[@ReecesPeanutButterCodes](https://github.com/ReecesPeanutButterCodes).\n* Add support for the [`Table.Reader`](https://hexdocs.pm/table/Table.html) protocol so that benchee works out of the box in Livebook. See [#369](https://github.com/bencheeorg/benchee/pull/369), big shoutout to [@akoutmos](https://github.com/akoutmos) and sorry for keeping it unreleased for so long.\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Removed Elixir 1.16 compiler warnings around +0.0 and -0.0. Thanks [@tomciop](https://github.com/tomciopp).\n* Building an escript and running it is fixed. See [#384](https://github.com/bencheeorg/benchee/issues/384) and thanks [@Munksgaard](https://github.com/Munksgaard)!","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"1.1.0 (2022-03-08) - Changelog","doc":"Long time, huh? I'm sorry, combination of priorities, difficult to fix bugs, stress and arm problems kept me away too long.\nThis release brings major features long developed and now finally released (reduction measurements + profiler after run), along with a critical bugfix around measurement accuracy for very fast functions (nanoseconds).\n\n#","ref":"changelog.html#1-1-0-2022-03-08"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* Reduction counting/measurements was implemented. Basically, it's a rather stable unit of execution implemented by the BEAM that measures in more abstract manner how much work was done. It's helpful, as it shouldn't be affected by load on the system. Check out [the docs](https://github.com/bencheeorg/benchee#measuring-reductions).\n* You can now dive straight into profiling from your benchmarks by using the profiling feature. See [the docs](https://github.com/bencheeorg/benchee#profiling-after-a-run) - thanks [@pablocostass](https://github.com/pablocostass)\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Default Behavior Changes (User Facing) - Changelog","doc":"* measuring function call overhead is now turned off by default, as it only helps with extreme nano benchmarks and has some potential for causing wrong results, so it should only be opt in. We now also print out the measured overhead for vsibility.\n\n#","ref":"changelog.html#default-behavior-changes-user-facing"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Benchee now correctly looks for the time resolution as reported by `:erlang.system_info(:os_monotonic_time_source)` to accommodate when determining if a measurement is \"precise\" enough. Benche also works around an erlang bug we discovered present in erlang <= 22.2. [Issue for reference](https://github.com/bencheeorg/benchee/issues/313).\n* The annoying stacktrace warning has been removed - thanks [@mad42](https://github.com/mad42)\n\n#","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"Noteworthy - Changelog","doc":"* a new dependency `statistex` will show up - it's a part of continued efforts to extract reusable libraries from Benchee.","ref":"changelog.html#noteworthy"},{"type":"extras","title":"1.0.1 (2019-04-09) - Changelog","doc":"#","ref":"changelog.html#1-0-1-2019-04-09"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* When memory measurements were actually different extended statistics was displayed although the option was not provided. Now correctly only displayed if the option is provided and values actually had variance.","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"1.0.0 (2019-03-28) - Changelog","doc":"It's 0.99.0 without the deprecation warnings. Specifically:\n\n* Old way of passing formatters (`:formatter_options`) vs. new `:formatters` with modules, tuples or functions with one arg\n* The configuration needs to be passed as the second argument to `Benchee.run/2`\n* `Benchee.collect/1` replaces `Benchee.measure/1`\n* `unit_scaling` is a top level configuration option, not for the console formatter\n* the warning for memory measurements not working on OTP <= 18 will also be dropped (we already officially dropped OTP 18 support in 0.14.0)\n\nWe're aiming to follow Semantic Versioning as we go forward. That means formatters should be safe to use `~> 1.0` (or even `>= 0.99.0 and < 2.0.0`).","ref":"changelog.html#1-0-0-2019-03-28"},{"type":"extras","title":"0.99.0 (2019-03-28) - Changelog","doc":"The \"we're almost 1.0!\" release - all the last small features, a bag of polish and deprecation warnings. If you run this release successfully without deprecation warnings you should be safe to upgrade to 1.0.0, if not - it's a bug :)\n\n#","ref":"changelog.html#0-99-0-2019-03-28"},{"type":"extras","title":"Breaking Changes (User Facing) - Changelog","doc":"* changed official Elixir compatibility to `~> 1.6`, 1.4+ should still work but aren't guaranteed or tested against.\n\n#","ref":"changelog.html#breaking-changes-user-facing"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* the console comparison now also displays the absolute difference in the average (like +12 ms) so that you have an idea to how much time that translates to in your applications not just that it's 100x faster\n* Overhaul of README, documentation, update samples etc. - a whole lot of things have also been marked `@doc false` as they're considered internal\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Remove double empty line after configuration display\n* Fix some wrong type specs\n\n#","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"* `Scenario` made it to the big leagues, it's no longer `Benchee.Benchmark.Scenario` but `Benchee.Scenario` - as it is arguably one of our most important data structures.\n* The `Scenario` struct had some keys changed (last time before 2.0 I promise!) - instead of `:run_times`/`:run_time_statistics` you now have one `run_time_data` key that contains `Benchee.CollectionData` which has the keys `:samples` and `:statistics`. Same for `memory_usage`. This was done to be able to handle different kinds of measurements more uniformly as we will add more of them.\n\n#","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* `Benchee.Statistics` comes with 3 new values: `:relative_more`, `:relative_less`, `:absolute_difference` so that you don't have to calculate these relative values yourself :)","ref":"changelog.html#features-plugins"},{"type":"extras","title":"0.14.0 (2019-02-10) - Changelog","doc":"Highlights of this release are a new way to specify formatter options closer to the formatters themselves as well as maximum precision measurements.\n\n#","ref":"changelog.html#0-14-0-2019-02-10"},{"type":"extras","title":"Breaking Changes (User Facing) - Changelog","doc":"* dropped support for Erlang 18.x\n* Formatters no longer have an `output/1` method, instead use `Formatter.output/3` please\n* Usage of `formatter_options` is deprecated, instead please use the new tuple way\n\n#","ref":"changelog.html#breaking-changes-user-facing"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* Benchee now uses the maximum precision available to measure which on Linux and OSX is nanoseconds instead of microseconds. Somewhat surprisingly `:timer.tc/1` always cut down to microseconds although better precision is available.\n* The preferred way to specify formatters and their options is to specify them as a tuple `{module, options}` instead of using `formatter_options`.\n* New `Formatter.output/1` function that takes a suite and uses all configured formatters to output their results\n* Add the concept of a benchmarking title that formatters can pick up\n* the displayed percentiles can now be adjusted\n* inputs option can now be an ordered list of tuples, this way you can determine their order\n* support FreeBSD properly (system metrics) - thanks @[kimshrier](/kimshrier)\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Remove extra double quotes in operating system report line - thanks @[kimshrier](/kimshrier)\n\n#","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"* all reported times are now in nanoseconds instead of microseconds\n* formatter methods `format` and `write` now take 2 arguments each where the additional arguments is the options specified for this formatter so that you have direct access to it without peeling it from the suite\n* You can no longer `use Benchee.Formatter` - just adopt the behaviour (no more auto generated `output/1` method, but `Formatter.output/3` takes that responsibility now)\n\n#","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* An optional title is now available in the suite for you to display\n* Scenarios are now sorted already sorted (first by run time, then memory usage) - no need to sort them yourself!\n* Add `Scenario.data_processed?/2` to check if either run time or memory data has had statistics generated","ref":"changelog.html#features-plugins"},{"type":"extras","title":"0.13.2 (2018-08-02) - Changelog","doc":"Mostly fixing memory measurement bugs and delivering them to you asap ;)\n\n#","ref":"changelog.html#0-13-2-2018-08-02"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Remove race condition that caused us to sometimes miss garbage collection events and hence report even negative or N/A results\n* restructure measuring code to produce less overhead (micro memory benchmarks should be much better now)\n* make console formatter more resilient to faulty memory measurements aka don't crash","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"0.13.1 (2018-05-02) - Changelog","doc":"Mostly fixing memory measurement bugs and related issues :) Enjoy a better memory measurement experience from now on!\n\n#","ref":"changelog.html#0-13-1-2018-05-02"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Memory measurements now correctly take the old generation on the heap into account. In reality that means sometimes bigger results and no missing measurements. See [#216](https://github.com/bencheeorg/benchee/pull/216) for details. Thanks to @michalmuskala for providing an interesting sample.\n* Formatters are now more robust (aka not crashing) when dealing with partially missing memory measurements. Although it shouldn't happen anymore with the item before fixed, Benchee shouldn't crash on you so we want to be on the safe side.\n* It's now possible to run just memory measurements (i.e. `time: 0, warmup: 0, memory_time: 1`)\n* even when you already have scenarios tagged with `-2` etc. it still correctly produces `-3`, `-4` etc. when saving again with the same \"base tagged name\"","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"0.13.0 (2018-04-14) - Changelog","doc":"Memory Measurements are finally here! Please report problems if you experience them.\n\n#","ref":"changelog.html#0-13-0-2018-04-14"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* Memory measurements obviously ;) Memory measurement are currently limited to process your function will be run in - memory consumption of other processes will **not** be measured. More information can be found in the [README](https://github.com/bencheeorg/benchee#measuring-memory-consumption). Only usable on OTP 19+. Special thanks go to @devonestes and @michalmuskala\n* new `pre_check` configuration option which allows users to add a dry run of all\nbenchmarks with each input before running the actual suite. This should save\ntime while actually writing the code for your benchmarks.\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Standard Deviation is now calculated correctly for being a sample of the population (divided by `n - 1` and not just `n`)","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"0.12.1 (2018-02-26) - Changelog","doc":"#","ref":"changelog.html#0-12-1-2018-02-26"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Formatters that use `FileCreation.each` will no longer silently fail on file\ncreation and now also sanitizes `/` and other file name characters to be `_`.\nThanks @gfvcastro","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"0.12.0 (2018-01-20) - Changelog","doc":"Adds the ability to save benchmarking results and load them again to compare\nagainst. Also fixes a bug for running benchmarks in parallel.\n\n#","ref":"changelog.html#0-12-0-2018-01-20"},{"type":"extras","title":"Breaking Changes (User Facing) - Changelog","doc":"* Dropped Support for elixir 1.3, new support is elixir 1.4+\n\n#","ref":"changelog.html#breaking-changes-user-facing"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* new `save` option specifying a path and a tag to save the results and tag them\n(for instance with `\"main\"`) and a `load` option to load those results again\nand compare them against your current results.\n* runs warning free with elixir 1.6\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* If you were running benchmarks in parallel, you would see results for each\nparallel process you were running. So, if you were running **two** jobs, and\nsetting your configuration to `parallel: 2`, you would see **four** results in the\nformatter. This is now correctly showing only the **two** jobs.\n\n#","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* `Scenario` has a new `name` field to be adopted for displaying the scenario names,\nas it includes the tag name and potential future additions.","ref":"changelog.html#features-plugins"},{"type":"extras","title":"0.11.0 (2017-11-30) - Changelog","doc":"A tiny little release with a bugfix and MOARE statistics for the console formatter.\n\n#","ref":"changelog.html#0-11-0-2017-11-30"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* estimated run times should be correct again, they were too high when inputs were used\n\n#","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* the console formatter accepts a new `extended_statistics` options that shows you additional statistics such as `minimum`, `maximum`, `sample_size` and the `mode`. Thanks `@lwalter`","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"0.10.0 (2017-10-24) - Changelog","doc":"This release focuses on 2 main things: the internal restructuring to use _scenarios_ and the new _hooks_ system. Other than that we also have some nice convenience features and formatters can be generated in parallel now.\n\n#","ref":"changelog.html#0-10-0-2017-10-24"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* Hooks system - basically you can now do something before/after a benchmarking scenario or the benchmarking function, too much to explain it in a Changelog, check the [README](https://github.com/bencheeorg/benchee#hooks-setup-teardown-etc)\n* Don't show more precision than we have - i.e. 234.00 microseconds (measurements are in microseconds and .00 doesn't gain you anything)\n* Limit precision of available memory displayed, you don't need to know 7.45678932 GB. Thanks to `@elpikel`.\n* Display the 99th percentile runtime. Thanks to `@wasnotrice`.\n* `:unit_scaling` is now a top level configuration option that can now also be used and picked up by formatters, like the HTML formatter\n* formatters can now be specified as a module (which should implement the `Benchee.Formatter` behaviour) - this makes specifying them nice and now at least their `format/1` functions can be executed in parallel\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* Determining CPUs was too strict/too assuming of a specific pattern breaking in certain environments (like Semaphore CI). That is more relaxed now thanks to `@predrag-rakic`!\n* Memory is now correctly converted using the binary (1024) interpretation, instead of the decimal one (1000)\n\n\n#","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* the statistics now also provide the mode of the samples as well as the 99th percentile\n* There is a new `Benchee.Formatter` behaviour to adopt and enforce a uniform format for formatters, best to do `use Benchee.Formatter`\n\n#","ref":"changelog.html#features-plugins"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"* `:run_times`, `:statistics` and `:jobs` have been removed and folded together into `:scenarios` - a scenario holds the benchmarking function, potentially the input, the raw run times measures and the computed statistics. With this data structure, all the relevant data for one scenario is one place although it takes a lot to change, this seems to be the best way going forward. Huge thanks to `@devonestes`!","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"0.9.0 (2017-06-08) - Changelog","doc":"This release focuses on adding more system specific information like CPU etc. and for better Erlang compatibility if you wanna use Benchee from Erlang. There is an [example project](https://github.com/bencheeorg/benchee_erlang_try) but calling Elixir from Erlang hasn't been as easy as I hoped :)\n\n#","ref":"changelog.html#0-9-0-2017-06-08"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* Gather more system data like number of cores, Operating System, memory, cpu speed - thanks @devonestes and @OvermindDL1\n* the names for jobs in the map of `Benchee.run/2` or in `Benchee.benchmark/3` may now be given as strings or atoms - atoms will be converted to strings internally though for consistency and avoiding name duplicates\n* the names of inputs in the Benchee configuration may now be given as strings or atoms - atoms will be converted to strings internally though for consistency and avoiding name duplicates\n* Benchee is now also available _\"Erlang Style\"_ to be called on an atom like `:benchee.run(_, _)` for better Erlang compatibility","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"0.8.0 (2017-05-07) - Changelog","doc":"Another smaller release that focuses on adding type specs and structs in appropriate places along with fixing a couple of small bugs.\n\n#","ref":"changelog.html#0-8-0-2017-05-07"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* Providing an unrecognized configuration option (say `runNtime` instead of `runtime`) will now raise an exception\n* Durations in the configuration will now be scaled appropriately (minutes, microseconds etc)\n* Major functions are type specced for your viewing pleasure in the docs and your dialyzer pleasure at type check time.\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Bugfixes (User Facing) - Changelog","doc":"* In 0.7.0 statistics generation might time out if Millions of run times were captured so that it takes longer than 5 seconds, this is fixed by waiting infinitely - thanks @devonestes for the [report](https://github.com/bencheeorg/benchee/issues/71).\n* Unintended line break in the fast function warning removed\n* All necessary dependencies added to `:applications` (deep_merge was missing)\n\n#","ref":"changelog.html#bugfixes-user-facing"},{"type":"extras","title":"Breaking Changes (User Facing) - Changelog","doc":"* Dropped support for elixir 1.2, new support is elixir 1.3+\n* `Benchee.Config` was renamed to `Benchee.Configuration` (important when you use the more verbose API or used it in a Plugin)\n\n#","ref":"changelog.html#breaking-changes-user-facing"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* Major public interfacing functions are now typespecced!\n* A couple of major data structures are now proper structs e.g. `Benchee.Suite`, `Benchee.Configuration`, `Benchee.Statistics`\n\n#","ref":"changelog.html#features-plugins"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"* The `config` key is now `configuration` to go along with the Configuration name change\n* As `Benchee.Configuration` is a proper struct now, arbitrary keys don't end up in it anymore. Custom data for plugins should be passed in through `formatter_options` or `assigns`. Existing plugin keys (`csv`, `json`, `html` and `console`) are automatically put into the `formatter_options` key space for now.","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"0.7.0 (April 23, 2017) - Changelog","doc":"Smaller convenience features in here - the biggest part of work went into breaking reports in [benchee_html](https://github.com/bencheeorg/benchee_html) apart :)\n\n#","ref":"changelog.html#0-7-0-april-23-2017"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* the print out of the Erlang version now is less verbose (just major/minor)\n* the fast_warning will now also tell you how to disable it\n* When `print: [benchmarking: false]` is set, information about which input is being benchmarked at the moment also won't be printed\n* generation of statistics parallelized (thanks hh.ex - @nesQuick and @dszam)\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Breaking Changes (User Facing) - Changelog","doc":"* If you use the more verbose interface (`Benchee.init` and friends, e.g. not `Benchee.run`) then you have to insert a `Benchee.system` call before `Benchee.measure` (preferably right after `Benchee.init`)\n\n#","ref":"changelog.html#breaking-changes-user-facing"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* `Benchee.Utility.FileCreation.interleave/2` now also accepts a list of inputs which are then all interleaved in the file name appropriately. See the doctests for more details.\n\n#","ref":"changelog.html#features-plugins"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"* `Benchee.measure/1` now also needs to have the system information generated by `Benchee.system/1` present if configuration information should be printed.","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"0.6.0 (November 30, 2016) - Changelog","doc":"One of the biggest releases yet. Great stuff in here - more elixir like API for `Benchee.run/2` with the jobs as the primary argument and the optional options as the second argument and now also as the more idiomatic keyword list!\n\nThe biggest feature apart from that is the possibility to use multiple inputs - which you all should do now as quite many functions behave differently with bigger, smaller or differently shaped inputs. Apart from that a bulk of work has gone into making and supporting [benchee_html](https://github.com/bencheeorg/benchee_html)!\n\n#","ref":"changelog.html#0-6-0-november-30-2016"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* New `:inputs` configuration key that allows you to specify a map from input name to input value so that each defined benchmarking job is then executed with this input. For this to work the benchmarking function is called with the appropriate `input` as an argument. See [`samples/multiple_inputs.exs`](https://github.com/bencheeorg/benchee/blob/main/samples/multiple_inputs.exs) for an example. [#21]( https://github.com/bencheeorg/benchee/issues/21)\n* The highlevel `Benchee.run/2` is now more idiomatic elixir and takes the map of jobs as the first argument and a keyword list of options as the second (and last) argument. The old way of passing config as a map as the first argument and the jobs as the second argument still works, **but might be deprecated later on** [#47](https://github.com/bencheeorg/benchee/issues/47)\n* Along with that `Benchee.init/1` now also accepts keyword lists of course\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Breaking Changes (User Facing) - Changelog","doc":"* The old way of providing the jobs as a list of tuples now removed, please switch to using a map from string to functions\n\n#","ref":"changelog.html#breaking-changes-user-facing"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* `Benchee.Utility.FileCreation` module to help with creating files from a map of multiple inputs (or other descriptors) mapping to input and an `interleave` function that spits out the correct file names especially if the `:__no_input` marker is used\n* `Benchee.System` is available to retrieve Elixir and Erlang versions but it's\nalso already added to the suite during `Benchee.run/2`\n\n#","ref":"changelog.html#features-plugins"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"* The structure of the output from `Benchee.Benchmark.measure/1` to `Benchee.Statistics.statistics/1` has changed to accommodate the new inputs feature there is now an additional level where in a map the input name then points to the appropriate results of the jobs. When there were no inputs the key is the value returned by `Benchee.Benchmark.no_input/0`.\n\n#","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"Bugfixes - Changelog","doc":"* prewarming (discarding the first result due to some timer issues) during run time was removed, as it should already happen during the warmup period and would discard actual useful results especially for longer running macro benchmarks.\n* when the execution time of the benchmarking job exceeds the given `:time` it will now execute exactly once (used to be 2) [#49](https://github.com/bencheeorg/benchee/issues/49)\n* `run_times` are now in the order as recorded (used to be reverse) - important when wants to graph them/look at them to see if there are any anomalies during benchmarking\n* Remove elixir 1.4.0-rc.0 warnings","ref":"changelog.html#bugfixes"},{"type":"extras","title":"0.5.0 (October 13, 2016) - Changelog","doc":"This release focuses on scaling units to more appropriate sizes. Instead of always working with base one for counts and microseconds those values are scaled accordingly to thousands, milliseconds for better readability. This work was mostly done by new contributor @wasnotrice.\n\n#","ref":"changelog.html#0-5-0-october-13-2016"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* Console output now scales units to be more friendly. Examples:\n    * instead of \"44556677\" ips, you would see \"44.56 M\"\n    * instead of \"44556.77 μs\" run time, you would see \"44.56 ms\"\n* Console output for standard deviation omits the parentheses\n* Scaling of console output can be configured with the 4 different strategies `:best`, `:largest`, `:smallest` and `:none`. Refer to the documentation for their different properties.\n* Shortened the fast function warning and instead [linked to the wiki](https://github.com/bencheeorg/benchee/wiki/Benchee-Warnings#fast-execution-warning)\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* The statistics module now computes the `minimum`, `maximum` and `sample_size` (not yet shown in the console formatter)\n* you can rely on `Benchee.Conversion.Duration`, `Benchee.Conversion.Count` and `Benchee.Conversion.DeviationPercent` for help with formatting and scaling units\n\n#","ref":"changelog.html#features-plugins"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"* The `Benchee.Time`module is gone, if you relied on it for one reason or another it's succeeded by the more powerful `Benchee.Conversion.Duration`","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"0.4.0 (September 11, 2016) - Changelog","doc":"Focuses on making what Benchee print out configurable to make it fit to your preferences :)\n\n#","ref":"changelog.html#0-4-0-september-11-2016"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* The configuration now has a `:print` key where it is possible to configure in a map what Benchee prints out during benchmarking. All options are enabled by default (true). Options are:\n  * `:benchmarking`  - print when Benchee starts benchmarking a new job (Benchmarking name ..)\n  * `:configuration` - a summary of configured benchmarking options including estimated total run time is printed before benchmarking starts\n  * `:fast_warning` - warnings are displayed if functions are executed too    fast leading to inaccurate measures\n* There is also a new configuration option for the built-in console formatter. Which is also enabled by default:\n  * `:comparison` - if the comparison of the different benchmarking jobs (x times slower than) is shown\n* The pre-benchmarking output of the configuration now also prints the currently used Erlang and Elixir versions (similar to `elixir -v`)\n* Add a space between the benchmarked time and the unit (microseconds)","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"0.3.0 (July 11, 2016) - Changelog","doc":"This release switches internal data structures from lists of tuples to maps, allows the configuration of formatters, aggregates all values and hands them down so formatters can access the whole configuration, prints general configuration information and much more great stuff :)\n\n#","ref":"changelog.html#0-3-0-july-11-2016"},{"type":"extras","title":"Breaking Changes (User Facing) - Changelog","doc":"* The recommended data structure handed to `Benchee.run` was changed from a list of 2-element tuples to a map (`\"Name\" => benchmark_function`). However, **the old list of tuples still works but may be removed in future releases** (so it's not \"breaking\" _strictly_ speaking).\n* You **can not have benchmark jobs with the same names anymore**, the last one wins here. This was the reason why previously the data structure was a list of tuples. However, having benchmarks with the same name is nonsensical as you can't discern their results in the output any way.\n\n#","ref":"changelog.html#breaking-changes-user-facing"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"* main data structure to hold benchmarks and results was changed from a list of 2-element tuples to a map (`\"Name\" => values`). That is for the jobs, the run times as well as the statistics. However, if you used something like `Enum.each(data, fn({name, value}) -> .. end)` you are still fine though, cause Elixir is awesome :)\n\n#","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* now takes a `parallel: number` configuration option and will then execute each job in parallel in as many parallel processes as specified in `number`. This way you can gather more samples in the same time and also simulate a system more under load. This is tricky, however. One of the use cases is also stress testing a system. Thanks @ldr\n* the name column width is now determined based on the longest name. Thanks @alvinlindstam\n* Print general configuration information at the start of the benchmark, including warmup, time, parallel and an estimated total run time\n* New method `Benchee.Formatters.Console.output/1` that immediately prints to the console\n* now takes a `formatters: [&My.Format.function/1, &Benchee.Formatters.console.output/1]` configuration option with which multiple formatters for the same benchmarking run can be configured when using `Benchee.run/2`. E.g. you can print results to the console and create a csv from that same run. Defaults to the builtin Console formatter.\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* All previous configuration options are preserved after `Benchee.Statistics.statistics/1`, meaning there is access to raw run times as well as custom options etc. E.g. you could grab custom options like `%{csv: %{file: \"my_file_name.csv\"}}` to use.\n\n#","ref":"changelog.html#features-plugins"},{"type":"extras","title":"Bugfixes - Changelog","doc":"* name columns are no longer truncated after 30 characters. Thanks @alvinlindstam","ref":"changelog.html#bugfixes"},{"type":"extras","title":"0.2.0 (June 11, 2016) - Changelog","doc":"This release introduces warmup for benchmarks, nicer console output and the new `Benchee.measure` that runs the benchmarks previously defined instead of running them instantly.\n\n#","ref":"changelog.html#0-2-0-june-11-2016"},{"type":"extras","title":"Breaking Changes (User Facing) - Changelog","doc":"* `Benchee.benchmark/3` now doesn't run the benchmark anymore but simply adds it to `:jobs` in the config. The whole benchmark suite is then run via `Benchee.measure/1`. This only affects you if you used the more verbose way of defining benchmarks, `Benchee.run/2` still work as before.\n\n#","ref":"changelog.html#breaking-changes-user-facing"},{"type":"extras","title":"Breaking Changes (Plugins) - Changelog","doc":"* the defined benchmarking are now preserved after running the benchmark under the `:jobs` key of the suite. Run times are added to the `:run_times` key of the suite (important for alternative statistics implementations)\n\n#","ref":"changelog.html#breaking-changes-plugins"},{"type":"extras","title":"Features (User Facing) - Changelog","doc":"* configuring a warmup time to run functions before measurements are taken can be configured via the `warmup` key in the config defaulting to 2 (seconds)\n\n* statistics in console output are aligned right now for better comparisons\n* last blank line of console output removed\n\n#","ref":"changelog.html#features-user-facing"},{"type":"extras","title":"Features (Plugins) - Changelog","doc":"* additionally supply the total standard deviation of iterations per second as `std_dev_ips` after `Benchee.Statistics.statistics`\n\n#","ref":"changelog.html#features-plugins"},{"type":"extras","title":"Bugfixes - Changelog","doc":"* if no time/warmup is specified the function won't be called at all","ref":"changelog.html#bugfixes"},{"type":"extras","title":"0.1.0 (June 5, 2016) - Changelog","doc":"Initial release","ref":"changelog.html#0-1-0-june-5-2016"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2016 Tobias Pfeiffer\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Readme","doc":"# Benchee [![Hex Version](https://img.shields.io/hexpm/v/benchee.svg)](https://hex.pm/packages/benchee) [![Hex Docs](https://img.shields.io/badge/docs-hexpm-blue.svg)](https://hexdocs.pm/benchee/) [![CI](https://github.com/bencheeorg/benchee/workflows/CI/badge.svg)](https://github.com/bencheeorg/benchee/actions?query=branch%3Amain) [![Coverage Status](https://coveralls.io/repos/github/bencheeorg/benchee/badge.svg?branch=main)](https://coveralls.io/github/bencheeorg/benchee?branch=main) [![Total Download](https://img.shields.io/hexpm/dt/benchee.svg)](https://hex.pm/packages/benchee) [![License](https://img.shields.io/hexpm/l/benchee.svg)](https://github.com/bencheeorg/benchee/blob/main/LICENSE)\n\n**If you have benchmarked using elixir 1.14.0 - 1.16.0-rc.0, please check out [known issues](#known-issues)**\n\nLibrary for easy and nice (micro) benchmarking in Elixir. Benchee allows you to compare the performance of different pieces of code at a glance. It is also versatile and extensible, relying only on functions. There are also a bunch of [plugins](#plugins) to draw pretty graphs and more!\n\nBenchee runs each of your functions for a given amount of time after an initial warmup, it then measures their run time and optionally memory consumption. It then shows different statistical values like average, standard deviation etc. See [features](#features).\n\nBenchee has a nice and concise main interface, its behavior can be altered through lots of [configuration options](#configuration):\n\n```elixir\nlist = Enum.to_list(1..10_000)\nmap_fun = fn i -> [i, i * i] end\n\nBenchee.run(\n  %{\n    \"flat_map\" => fn -> Enum.flat_map(list, map_fun) end,\n    \"map.flatten\" => fn -> list |> Enum.map(map_fun) |> List.flatten() end\n  },\n  time: 10,\n  memory_time: 2\n)\n```\n\nProduces the following output on the console:\n\n```\nOperating System: Linux\nCPU Information: AMD Ryzen 9 5900X 12-Core Processor\nNumber of Available Cores: 24\nAvailable memory: 31.25 GB\nElixir 1.16.0-rc.1\nErlang 26.1.2\nJIT enabled: true\n\nBenchmark suite executing with the following configuration:\nwarmup: 2 s\ntime: 10 s\nmemory time: 2 s\nreduction time: 0 ns\nparallel: 1\ninputs: none specified\nEstimated total run time: 28 s\n\nBenchmarking flat_map ...\nBenchmarking map.flatten ...\nCalculating statistics...\nFormatting results...\n\nName                  ips        average  deviation         median         99th %\nflat_map           3.79 K      263.87 μs    ±15.49%      259.47 μs      329.29 μs\nmap.flatten        1.96 K      509.19 μs    ±51.36%      395.23 μs     1262.27 μs\n\nComparison:\nflat_map           3.79 K\nmap.flatten        1.96 K - 1.93x slower +245.32 μs\n\nMemory usage statistics:\n\nName           Memory usage\nflat_map             625 KB\nmap.flatten       781.25 KB - 1.25x memory usage +156.25 KB\n\n**All measurements for memory usage were the same**\n```\n\nThe aforementioned [plugins](#plugins) like [benchee_html](https://github.com/bencheeorg/benchee_html) make it possible to generate nice looking [HTML reports](http://www.pragtob.info/benchee/README/results.html), where individual graphs can also be exported as PNG images:\n\n![report](http://www.pragtob.info/benchee/images/report.png)","ref":"readme.html"},{"type":"extras","title":"Table of Contents - Readme","doc":"- [Table of Contents](#table-of-contents)\n- [Features](#features)\n  - [Statistics](#statistics)\n- [Installation](#installation)\n- [Usage](#usage)\n  - [Configuration](#configuration)\n  - [Metrics to measure](#metrics-to-measure)\n    - [Measuring time](#measuring-time)\n      - [A note on time measurement accuracy](#a-note-on-time-measurement-accuracy)\n    - [Measuring Memory Consumption](#measuring-memory-consumption)\n    - [Measuring Reductions](#measuring-reductions)\n  - [Inputs](#inputs)\n  - [Formatters](#formatters)\n    - [Console Formatter options](#console-formatter-options)\n  - [Profiling after a run](#profiling-after-a-run)\n  - [Saving, loading and comparing previous runs](#saving-loading-and-comparing-previous-runs)\n  - [Hooks (Setup, Teardown etc.)](#hooks-setup-teardown-etc)\n    - [Suite hooks](#suite-hooks)\n    - [Scenario hooks](#scenario-hooks)\n      - [What is a scenario?](#what-is-a-scenario)\n      - [before\\_scenario](#before_scenario)\n      - [after\\_scenario](#after_scenario)\n    - [Benchmarking function hooks](#benchmarking-function-hooks)\n      - [before\\_each](#before_each)\n      - [after\\_each](#after_each)\n    - [Hook arguments and return values](#hook-arguments-and-return-values)\n    - [Hook configuration: global versus local](#hook-configuration-global-versus-local)\n    - [When does a hook happen? (Complete Example)](#when-does-a-hook-happen-complete-example)\n  - [More verbose usage](#more-verbose-usage)\n  - [Usage from Erlang](#usage-from-erlang)\n- [Known Issues](#known-issues)\n- [Plugins](#plugins)\n- [Contributing ](#contributing-)\n- [Development](#development)\n- [Copyright and License](#copyright-and-license)","ref":"readme.html#table-of-contents"},{"type":"extras","title":"Features - Readme","doc":"* first runs the functions for a given warmup time without recording the results, to simulate a _\"warm\"/running_ system\n* [measures memory usage](#measuring-memory-consumption)\n* provides you with lots of [statistics](#statistics)\n* plugin/extensible friendly architecture so you can use different formatters to display benchmarking results as [HTML, markdown, JSON and more](#plugins)\n* measure not only [time](#measuring-time), but also measure [memory](#measuring-memory-consumption) and [reductions](#measuring-reductions)\n* [profile](#profiling-after-a-run) right after benchmarking\n* as precise as it can get, measure with up to nanosecond precision (Operating System dependent)\n* nicely formatted console output with units scaled to appropriately (nanoseconds to minutes)\n* (optionally) measures the overhead of function calls so that the measured/reported times really are the execution time of _your_code_ without that overhead.\n* [hooks](#hooks-setup-teardown-etc) to execute something before/after a benchmarking invocation, without it impacting the measured time\n* execute benchmark jobs in parallel to gather more results in the same time, or simulate a system under load\n* well documented & well tested\n\n#","ref":"readme.html#features"},{"type":"extras","title":"Statistics - Readme","doc":"Provides you with the following **statistical data**:\n\n* **average**   - average execution time/memory usage (the lower the better)\n* **ips**       - iterations per second, aka how often can the given function be executed within one second (the higher the better - good for graphing), only for run times\n* **deviation** - standard deviation (how much do the results vary), given as a percentage of the average (raw absolute values also available)\n* **median**    - when all measured values are sorted, this is the middle value. More stable than the average and somewhat more likely to be a typical value you see, for the most typical value see mode. (the lower the better)\n* **99th %**    - 99th percentile, 99% of all measured values are less than this - worst case performance-ish\n\nIn addition, you can optionally output an extended set of statistics:\n\n* **minimum**     - the smallest value measured for the job (fastest/least consumption)\n* **maximum**     - the biggest run time measured for the job (slowest/most consumption)\n* **sample size** - the number of measurements taken\n* **mode**        - the measured values that occur the most. Often one value, but can be multiple values if they occur exactly as often. If no value occurs at least twice, this value will be `nil`.","ref":"readme.html#statistics"},{"type":"extras","title":"Installation - Readme","doc":"Add `:benchee` to your list of dependencies in `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    {:benchee, \"~> 1.0\", only: :dev}\n  ]\nend\n```\n\nInstall via `mix deps.get` and then happy benchmarking as described in [Usage](#usage) :)\n\nElixir versions supported/tested against are 1.7+. It _should_ theoretically still work with 1.4, 1.5 & 1.6 but we don't actively test/support it as installing them on current CI systems is not supported out of the box.","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Readme","doc":"After installing just write a little Elixir benchmarking script:\n\n```elixir\nlist = Enum.to_list(1..10_000)\nmap_fun = fn i -> [i, i * i] end\n\nBenchee.run(\n  %{\n    \"flat_map\" => fn -> Enum.flat_map(list, map_fun) end,\n    \"map.flatten\" => fn -> list |> Enum.map(map_fun) |> List.flatten() end\n  }\n)\n```\n\n(names can also be specified as `:atoms` if you want to)\n\nThis produces the following output:\n\n```\ntobi@speedy:$ mix run samples/run_defaults.exs\nOperating System: Linux\nCPU Information: Intel(R) Core(TM) i7-4790 CPU @ 3.60GHz\nNumber of Available Cores: 8\nAvailable memory: 15.61 GB\nElixir 1.8.1\nErlang 21.2.7\n\nBenchmark suite executing with the following configuration:\nwarmup: 2 s\ntime: 5 s\nmemory time: 0 ns\nparallel: 1\ninputs: none specified\nEstimated total run time: 14 s\n\nBenchmarking flat_map...\nBenchmarking map.flatten...\n\nName                  ips        average  deviation         median         99th %\nflat_map           2.34 K      427.78 μs    ±16.02%      406.29 μs      743.01 μs\nmap.flatten        1.22 K      820.87 μs    ±19.29%      772.61 μs     1286.35 μs\n\nComparison:\nflat_map           2.34 K\nmap.flatten        1.22 K - 1.92x slower +393.09 μs\n```\n\nSee [Features](#features) for a description of the different statistical values and what they mean.\n\nIf you're looking to see how to make something specific work, please refer to the [samples](https://github.com/bencheeorg/benchee/tree/main/samples) directory. Also, especially when wanting to extend Benchee, check out the [hexdocs](https://hexdocs.pm/benchee/api-reference.html).\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - Readme","doc":"Benchee takes a wealth of configuration options, however those are entirely optional. Benchee ships with sensible defaults for all of these.\n\nIn the most common `Benchee.run/2` interface configuration options are passed as the second argument in the form of an keyword list:\n\n```elixir\nBenchee.run(%{\"some function\" => fn -> magic end}, print: [benchmarking: false])\n```\n\nThe available options are the following (also documented in [hexdocs](https://hexdocs.pm/benchee/Benchee.Configuration.html#init/1)).\n\n* `warmup` - the time in seconds for which a benchmarking job should be run without measuring anything before \"real\" measurements start. This simulates a _\"warm\"/running_ system. Defaults to 2.\n* `time` - the time in seconds for how long each individual scenario (benchmarking job x input) should be run for measuring the execution times (run time performance). Defaults to 5.\n* `memory_time` - the time in seconds for how long [memory measurements](#measuring-memory-consumption) should be conducted. Defaults to 0 (turned off).\n* `reduction_time` - the time in seconds for how long [reductions are measured](#measuring-memory-reductions) should be conducted. Defaults to 0 (turned off).\n* `inputs` - a map or list of two element tuples. If a map, the keys are descriptive input names and values are the actual input values. If a list of tuples, the first element in each tuple is the input name, and the second element in each tuple is the actual input value. Your benchmarking jobs will then be run with each of these inputs. For this to work your benchmarking function gets the current input passed in as an argument into the function. Defaults to `nil`, aka no input specified and functions are called without an argument. See [Inputs](#inputs).\n* `formatters` - list of formatters either as a module implementing the formatter behaviour, a tuple of said module and options it should take or formatter functions. They are run when using `Benchee.run/2` or you can invoke them through `Benchee.Formatter.output/1`. Functions need to accept one argument (which is the benchmarking suite with all data) and then use that to produce output. Used for plugins & configuration. Also allows the configuration of the console formatter to print extended statistics. Defaults to the builtin console formatter `Benchee.Formatters.Console`. See [Formatters](#formatters).\n* `measure_function_call_overhead` - Measure how long an empty function call takes and deduct this from each measured run time. This overhead should be negligible for all but the most micro benchmarks. Defaults to false.\n* `pre_check` - whether or not to run each job with each input - including all given before or after scenario or each hooks - before the benchmarks are measured to ensure that your code executes without error. This can save time while developing your suites. Defaults to `false`.\n* `parallel` - the function of each benchmarking job will be executed in `parallel` number processes. If `parallel: 4` then 4 processes will be spawned that all execute the _same_ function for the given time. When `time` seconds have passed, 4 new processes will be spawned for the next scenario (meaning a new input or another function to be benchmarked). This gives you more data in the same time, but also puts load on the system interfering with benchmark results. For more on the pros and cons of parallel benchmarking [check the wiki](https://github.com/bencheeorg/benchee/wiki/Parallel-Benchmarking). Defaults to 1 (no parallel execution).\n* `save` - specify a `path` where to store the results of the current benchmarking suite, tagged with the specified `tag`. See [Saving & Loading](#saving-loading-and-comparing-previous-runs).\n* `load` - load saved suite or suites to compare your current benchmarks against. Can be a string or a list of strings or patterns. See [Saving & Loading](#saving-loading-and-comparing-previous-runs).\n* `print` - a map or keyword list from atoms to `true` or `false` to configure if the output identified by the atom will be printed during the standard Benchee benchmarking process. All options are enabled by default (true). Options are:\n  * `:benchmarking`  - print when Benchee starts benchmarking a new job (`Benchmarking name ...`) as well as when statistics are being calculated or formatting begins.\n  * `:configuration` - a summary of configured benchmarking options including estimated total run time is printed before benchmarking starts\n  * `:fast_warning` - warnings are displayed if functions are executed too fast leading to inaccurate measures\n* `:unit_scaling` - the strategy for choosing a unit for durations,\n  counts & memory measurements. May or may not be implemented by a given formatter (The console formatter implements it).\n  When scaling a value, Benchee finds the \"best fit\"\n  unit (the largest unit for which the result is at least 1). For example,\n  1_200_000 scales to `1.2 M`, while `800_000` scales to `800 K`. The\n  `unit_scaling` strategy determines how Benchee chooses the best fit unit for\n  an entire list of values, when the individual values in the list may have\n  different best fit units. There are four strategies, defaulting to `:best`:\n    * `:best`     - the most frequent best fit unit will be used, a tie\n    will result in the larger unit being selected.\n    * `:largest`  - the largest best fit unit will be used\n    * `:smallest` - the smallest best fit unit will be used\n    * `:none`     - no unit scaling will occur.\n* `:before_scenario`/`after_scenario`/`before_each`/`after_each` - read up on them in the [hooks section](#hooks-setup-teardown-etc)\n* `profile_after` - accepts any of the following options:\n    * a boolean   - `true` will enable profiling with the default profiler (`:eprof`) and `false` will disable profiling. Defaults to `false`.\n    * a profiler  - either as a tuple of `{profiler, opts}` (e.g., `{:fprof, [sort: :own]}`) or just the profiler (e.g., `:fprof`),\n    which is equivalent to `{profiler, []}`. The accepted built-in profilers are\n    [`:cprof`](https://hexdocs.pm/mix/Mix.Tasks.Profile.Cprof.html),\n    [`:eprof`](https://hexdocs.pm/mix/Mix.Tasks.Profile.Eprof.html) and\n    [`:fprof`](https://hexdocs.pm/mix/Mix.Tasks.Profile.Fprof.html).\n\n#","ref":"readme.html#configuration"},{"type":"extras","title":"Metrics to measure - Readme","doc":"Benchee can't only measure [execution time](#measuring-time), but also [memory consumption](#measuring-memory-consumption) and [reductions](#measuring-reductions)!\n\nYou can measure one of these metrics, or all at the same time. The choice is up to you. Warmup will only occur once though, the time for measuring the metrics are governed by `time`, `memory_time` and `reduction_time` configuration values respectively.\n\nBy default only execution time is measured, memory and reductions need to be opted in by specifying a non 0 time amount.\n\n##","ref":"readme.html#metrics-to-measure"},{"type":"extras","title":"Measuring time - Readme","doc":"This is the default, which you'll most likely want to use as you want to measure how fast your system processes something or responds to a request. Benchee does its best to measure time as accurately and as scoped to your function as possible.\n\n```elixir\nBenchee.run(\n  %{\n    \"something_great\" => fn -> cool_stuff end\n  },\n  warmup: 1,\n  time: 5,\n  memory_time: 2,\n  reduction_time: 2\n)\n```\n\n###","ref":"readme.html#measuring-time"},{"type":"extras","title":"A note on time measurement accuracy - Readme","doc":"From system to system the resolution of the clock [can vary](https://www.erlang.org/doc/apps/erts/time_correction.html).\n\nGenerally speaking we have seen accuracies down to 1 nanosecond on Linux and ~1 microsecond onb both OSX and Windows. We have also seen accuracy as low as 10ms on Windows in a CI environment.\nThese numbers are not a limitation of Benchee, but of the Operating System (or at the very least how erlang makes it available).\n\nIf your benchmark takes 100s of microseconds this likely has no/little impact, but **if you want to do extremely nano benchmarks we recommend doing them on Linux**.\n\nSo, what happens if a function executes too fast for Benchee to measure? If Benchee recognizes this (not always possible) it will automatically take the function and repeat it multiple times. This way a function that takes 2 microseconds will take ~20 microseconds and differences can be measured even with microsecond accuracy. Naturally, this comes at several disadvantages:\n\n* The looping/repetition code is now measured alongside the function\n* essentially every single measurement is now an average across 10 runs making lots of statistics less meaningful\n\nBenchee will print a big warning when this happens.\n##","ref":"readme.html#a-note-on-time-measurement-accuracy"},{"type":"extras","title":"Measuring Memory Consumption - Readme","doc":"Starting with version 0.13, users can now get measurements of how much memory their benchmarked scenarios use. The measurement is **limited to the process that Benchee executes your provided code in** - i.e. other processes (like worker pools)/the whole BEAM isn't taken into account.\n\nThis measurement is **not** the actual effect on the size of the BEAM VM size, but the total amount of memory that was allocated during the execution of a given scenario. This includes all memory that was garbage collected during the execution of that scenario.\n\nThis measurement of memory does not affect the measurement of run times.\n\nIn cases where all measurements of memory consumption are identical, which happens very frequently, the full statistics will be omitted from the standard console formatter. If your function is deterministic, this should always be the case. Only in functions with some amount of randomness will there be variation in memory usage.\n\nMemory measurement is disabled by default, you can choose to enable it by passing `memory_time: your_seconds` option to `Benchee.run/2`:\n\n```elixir\nBenchee.run(\n  %{\n    \"something_great\" => fn -> cool_stuff end\n  },\n  memory_time: 2\n)\n```\n\nMemory time can be specified separately as it will often be constant - so it might not need as much measuring time.\n\nA full example, including an example of the console output, can be found\n[here](samples/measure_memory.exs).\n\n##","ref":"readme.html#measuring-memory-consumption"},{"type":"extras","title":"Measuring Reductions - Readme","doc":"Starting in versions 1.1.0 Benchee can measure reductions - but what are reductions?\n\nIn short, it's not very well defined but a \"unit of work\". The BEAM uses them to keep track of how long a process has run. As [the Beam Book puts it as follows](https://blog.stenmans.org/theBeamBook/#_scheduling_non_preemptive_reduction_counting):\n\n>BEAM solves this by keeping track of how long a process has been running. This is done by counting reductions. The term originally comes from the mathematical term beta-reduction used in lambda calculus.\n>\n>The definition of a reduction in BEAM is not very specific, but we can see it as a small piece of work, which shouldn’t take too long. Each function call is counted as a reduction. BEAM does a test upon entry to each function to check whether the process has used up all its reductions or not. If there are reductions left the function is executed otherwise the process is suspended.\n\nNow, why would you want to measure this? Well, apart from BIFs & NIFs, which are not accurately tracked through this, it gives an impression of how much work the BEAM is doing. And the great thing is, this is independent of the load the system is under as well as the hardware. Hence, it gives you a way to check performance that is less volatile so suitable for CI for instance.\n\nIt can slightly differ between elixir & erlang versions, though.\n\n**Like memory measurements, this only tracks reductions directly in the function given to benchee, not processes spawned by it or other processes it uses.**\n\nReduction measurement is disabled by default, you can choose to enable it by passing `reduction_time: your_seconds` option to `Benchee.run/2`:\n\n```elixir\nBenchee.run(\n  %{\n    \"something_great\" => fn -> cool_stuff end\n  },\n  reduction_time: 2\n)\n```\n\nAlso like memory measurements, reduction measurements will often be constant unless something changes about the execution of the benchmarking function.\n\n#","ref":"readme.html#measuring-reductions"},{"type":"extras","title":"Inputs - Readme","doc":"`:inputs` is a very useful configuration that allows you to run the same benchmarking jobs with different inputs. We call this combination a _\"scenario\"_. You specify the inputs as either a map from name (String or atom) to the actual input value or a list of tuples where the first element in each tuple is the name and the second element in the tuple is the value.\n\nWhy do this? Functions can have different performance characteristics on differently shaped inputs - be that structure or input size. One of such cases is comparing tail-recursive and body-recursive implementations of `map`. More information in the [repository with the benchmark](https://github.com/PragTob/elixir_playground/blob/main/bench/tco_blog_post_focussed_inputs.exs) and the [blog post](https://pragtob.wordpress.com/2016/06/16/tail-call-optimization-in-elixir-erlang-not-as-efficient-and-important-as-you-probably-think/).\n\nAs a little sample:\n\n```elixir\nmap_fun = fn i -> [i, i * i] end\n\nBenchee.run(\n  %{\n    \"flat_map\" => fn input -> Enum.flat_map(input, map_fun) end,\n    \"map.flatten\" => fn input -> input |> Enum.map(map_fun) |> List.flatten() end\n  },\n  inputs: %{\n    \"Small\" => Enum.to_list(1..1_000),\n    \"Medium\" => Enum.to_list(1..10_000),\n    \"Bigger\" => Enum.to_list(1..100_000)\n  }\n)\n```\n\nThis means each function will be benchmarked with each input that is specified in the inputs. Then you'll get the output divided by input so you can see which function is fastest for which input, like so:\n\n```\ntobi@speedy:~/github/benchee(readme-overhaul)$ mix run samples/multiple_inputs.exs\n\n(... general information ...)\n\n###","ref":"readme.html#inputs"},{"type":"extras","title":"With input Bigger ##### - Readme","doc":"Name                  ips        average  deviation         median         99th %\nflat_map           150.81        6.63 ms    ±12.65%        6.57 ms        8.74 ms\nmap.flatten        114.05        8.77 ms    ±16.22%        8.42 ms       12.76 ms\n\nComparison:\nflat_map           150.81\nmap.flatten        114.05 - 1.32x slower +2.14 ms\n\n###","ref":"readme.html#with-input-bigger"},{"type":"extras","title":"With input Medium ##### - Readme","doc":"Name                  ips        average  deviation         median         99th %\nflat_map           2.28 K      437.80 μs    ±10.72%      425.63 μs      725.09 μs\nmap.flatten        1.78 K      561.18 μs     ±5.55%      553.98 μs      675.98 μs\n\nComparison:\nflat_map           2.28 K\nmap.flatten        1.78 K - 1.28x slower +123.37 μs\n\n###","ref":"readme.html#with-input-medium"},{"type":"extras","title":"With input Small ##### - Readme","doc":"Name                  ips        average  deviation         median         99th %\nflat_map          26.31 K       38.01 μs    ±15.47%       36.69 μs       67.08 μs\nmap.flatten       18.65 K       53.61 μs    ±11.32%       52.79 μs       70.17 μs\n\nComparison:\nflat_map          26.31 K\nmap.flatten       18.65 K - 1.41x slower +15.61 μs\n```\n\nTherefore, we **highly recommend** using this feature and checking different realistically structured and sized inputs for the functions you benchmark!\n\n#","ref":"readme.html#with-input-small"},{"type":"extras","title":"Formatters - Readme","doc":"Among all the configuration options, one that you probably want to use are the formatters. They format and print out the results of the benchmarking suite.\n\nThe `:formatters` option is specified a list of:\n* modules implementing the `Benchee.Formatter` behaviour\n* a tuple of a module specified above and options for it `{module, options}`\n* functions that take one argument (the benchmarking suite with all its results) and then do whatever you want them to\n\nSo if you are using the [HTML plugin](https://github.com/bencheeorg/benchee_html) and you want to run both the console formatter and the HTML formatter this looks like this (after you installed it of course):\n\n```elixir\nlist = Enum.to_list(1..10_000)\nmap_fun = fn i -> [i, i * i] end\n\nBenchee.run(\n  %{\n    \"flat_map\"    => fn -> Enum.flat_map(list, map_fun) end,\n    \"map.flatten\" => fn -> list |> Enum.map(map_fun) |> List.flatten end\n  },\n  formatters: [\n    {Benchee.Formatters.HTML, file: \"samples_output/my.html\"},\n    Benchee.Formatters.Console\n  ]\n)\n```\n\n##","ref":"readme.html#formatters"},{"type":"extras","title":"Console Formatter options - Readme","doc":"The console formatter supports 2 configuration options:\n\n  * `:comparison` - if the comparison of the different benchmarking jobs (x times slower than) is shown. Enabled by default.\n  * `extended_statistics` - display more statistics, aka `minimum`, `maximum`, `sample_size` and `mode`. Disabled by default.\n\nSo if you want to see more statistics you simple pass `extended_statistics: true` to the console formatter:\n\n```elixir\nlist = Enum.to_list(1..10_000)\nmap_fun = fn i -> [i, i * i] end\n\nBenchee.run(\n  %{\n    \"flat_map\" => fn -> Enum.flat_map(list, map_fun) end,\n    \"map.flatten\" => fn -> list |> Enum.map(map_fun) |> List.flatten() end\n  },\n  time: 10,\n  formatters: [{Benchee.Formatters.Console, extended_statistics: true}]\n)\n```\n\nWhich produces:\n\n```\n(... normal output ...)\n\nExtended statistics:\n\nName                minimum        maximum    sample size                     mode\nflat_map          345.43 μs     1195.89 μs        23.73 K                405.64 μs\nmap.flatten       522.99 μs     2105.56 μs        12.03 K     767.83 μs, 768.44 μs\n```\n\n(Btw. notice how the modes of both are much closer and for `map.flatten` much less than the average of `766.99`, see `samples/run_extended_statistics`)\n\n#","ref":"readme.html#console-formatter-options"},{"type":"extras","title":"Profiling after a run - Readme","doc":"Often time when benchmarking, you want to improve performance. However, Benchee only tells you how fast something is, it doesn't tell you what part of your code is slow. This is where profiling comes in.\n\nBenchee offers you the `profile_after` option to run a profiler of your choice after a benchmarking run to see what's slow. This will run every scenario once.\n\nBy default it will run the `:eprof` profiler, different profilers with different options can be used - see [configuration](#configuration).\n\n```elixir\nlist = Enum.to_list(1..10_000)\nmap_fun = fn i -> [i, i * i] end\n\nBenchee.run(\n  %{\n    \"flat_map\" => fn -> Enum.flat_map(list, map_fun) end,\n    \"map.flatten\" => fn -> list |> Enum.map(map_fun) |> List.flatten() end\n  },\n  profile_after: true\n)\n```\n\nAfter the normal benchmarking, this results prints profiles like:\n\n```\nProfiling flat_map with eprof...\nWarmup...\n\n\nProfile results of #PID<0.1885.0>\n#                                               CALLS     % TIME µS/CALL\nTotal                                           30004 100.0 5665    0.19\nEnum.flat_map/2                                     1  0.00    0    0.00\nanonymous fn/2 in :elixir_compiler_1.__FILE__/1     1  0.00    0    0.00\n:erlang.apply/2                                     1  0.04    2    2.00\n:erlang.++/2                                    10000 18.38 1041    0.10\nanonymous fn/1 in :elixir_compiler_1.__FILE__/1 10000 28.12 1593    0.16\nEnum.flat_map_list/2                            10001 53.47 3029    0.30\n\nProfile done over 6 matching functions\n\nProfiling map.flatten with eprof...\nWarmup...\n\n\nProfile results of #PID<0.1887.0>\n#                                               CALLS     % TIME µS/CALL\nTotal                                           60007 100.0 8649    0.14\nEnum.map/2                                          1  0.00    0    0.00\nanonymous fn/2 in :elixir_compiler_1.__FILE__/1     1  0.00    0    0.00\nList.flatten/1                                      1  0.00    0    0.00\n:lists.flatten/1                                    1  0.00    0    0.00\n:erlang.apply/2                                     1  0.02    2    2.00\nanonymous fn/1 in :elixir_compiler_1.__FILE__/1 10000 16.35 1414    0.14\nEnum.\"-map/2-lists^map/1-0-\"/2                  10001 26.38 2282    0.23\n:lists.do_flatten/2                             40001 57.24 4951    0.12\n```\n\n**Note about after_each hooks:** `after_each` hooks currently don't work when profiling a function, as they are not passed the return value of the function after the profiling run. It's already fixed on the elixir side and is waiting for release, likely in 1.14. It should then just work.\n\n#","ref":"readme.html#profiling-after-a-run"},{"type":"extras","title":"Saving, loading and comparing previous runs - Readme","doc":"Benchee can store the results of previous runs in a file and then load them again to compare them. For example this is useful to compare what was recorded on the main branch against a branch with performance improvements. You may also use this to benchmark across different exlixir/erlang versions.\n\n**Saving** is done through the `:save` configuration option. You can specify a `:path` where results are saved, or you can use the default option of`\"benchmark.benchee\"` if you don't pass a `:path`. You can also pass a `:tag` option which annotates these results (for instance with a branch name or elixir version number). The default option for the `:tag` is a timestamp of when the benchmark was run.\n\n**Loading** is done through the `:load` option specifying a path to the file to load (for instance `\"benchmark.benchee\"`). You can also specify multiple files to load through a list of paths (`[\"my.benchee\", \"main_save.benchee\"]`) - each one of those can also be a glob expression to match even more files glob (`\"save_number*.benchee\"`).\nIn the more verbose API loading is triggered via `Benchee.load/1`.\nIf all you want to do is to use `:load` without running any benchmarks then you can use `Benchee.report/1` which will take a normal configuration with a `:load` key and just format the loaded saved results with the given formatters.\n\n```elixir\nBenchee.run(\n  %{\n    \"something_great\" => fn -> cool_stuff end\n  },\n  save: [path: \"save.benchee\", tag: \"first-try\"]\n)\n\nBenchee.report(load: \"save.benchee\")\n```\n\n#","ref":"readme.html#saving-loading-and-comparing-previous-runs"},{"type":"extras","title":"Hooks (Setup, Teardown etc.) - Readme","doc":"Most of the time, it's best to keep your benchmarks as simple as possible: plain old immutable functions work best. But sometimes you need other things to happen. When you want to add before or after hooks to your benchmarks, we've got you covered! Before you dig into this section though remember one thing: **you usually don't need hooks!**\n\nBenchee has three types of hooks:\n\n* [Suite hooks](#suite-hooks)\n* [Scenario hooks](#scenario-hooks)\n* [Benchmarking function hooks](#benchmarking-function-hooks)\n\n\nOf course, **hooks are not included in the measurements**. So they are there especially if you want to do something and want it to **not be included in the measurements**. Sadly there is the notable exception of _too_fast_functions_ (the ones that execute faster than we can measure in [_native_ resolution](#a-note-on-time-measurement-accuracy)). As we need to measure their repeated invocations to get halfway good measurements `before_each` and `after_each` hooks are included there. However, to the best of our knowledge this should only ever happen on Windows (because of the bad run time measurement accuracy).\n\n##","ref":"readme.html#hooks-setup-teardown-etc"},{"type":"extras","title":"Suite hooks - Readme","doc":"It is very easy in Benchee to do setup and teardown for the whole benchmarking suite (think: \"before all\" and \"after all\"). As Benchee is just plain old functions, just do your setup and teardown before/after you call Benchee:\n\n```elixir\nyour_setup()\n\nBenchee.run(%{\"Awesome stuff\" => fn -> magic end})\n\nyour_teardown()\n```\n\n_When might this be useful?_\n\n* Seeding the database with data to be used by all benchmarking functions\n* Starting/shutting down a server, process, other dependencies\n\n##","ref":"readme.html#suite-hooks"},{"type":"extras","title":"Scenario hooks - Readme","doc":"For the following discussions, it's important to know what benchee considers a \"benchmarking scenario\".\n\n###","ref":"readme.html#scenario-hooks"},{"type":"extras","title":"What is a scenario? - Readme","doc":"A scenario is the combination of one benchmarking function and one input. So, given this benchmark:\n\n```elixir\nBenchee.run(\n  %{\n    \"foo\" => fn input -> ... end,\n    \"bar\" => fn input -> ... end\n  },\n  inputs: %{\n    \"input 1\" => 1,\n    \"input 2\" => 2\n  }\n)\n```\n\nthere are 4 scenarios:\n\n1. foo with input 1\n2. foo with input 2\n3. bar with input 1\n4. bar with input 2\n\nA scenario includes warmup and actual run time (+ other measurements like memory).\n\n###","ref":"readme.html#what-is-a-scenario"},{"type":"extras","title":"before_scenario - Readme","doc":"Is executed before every [scenario](#what-is-a-scenario) that it applies to (see [hook configuration](#hook-configuration-global-versus-local)). `before_scenario` hooks take the input of the scenario as an argument.\n\nSince the return value of a `before_scenario` becomes the input for next steps (see [hook arguments and return values](#hook-arguments-and-return-values)),  there usually are 3 kinds of before scenarios:\n\n* you just want to invoke a side effect: in that case return the given input unchanged\n* you want to alter the given input: in that case alter the given input\n* you want to keep the given input but add some other data: in that case return a tuple like `{original_input, new_fancy_data}`\n\nFor before scenario hooks, the _global_ hook is invoked first, then the _local_ (see [when does a hook happen?](#when-does-a-hook-happen-complete-example)).\n\nUsage:\n\n```elixir\nBenchee.run(\n  %{\n    \"foo\" =>\n      {\n        fn {input, resource} -> foo(input, resource) end,\n        before_scenario: fn {input, resource} ->\n          resource = alter_resource(resource)\n          {input, resource}\n        end\n      },\n    \"bar\" =>\n      fn {input, resource} -> bar(input, resource) end\n  },\n  inputs: %{\"input 1\" => 1},\n  before_scenario: fn input ->\n    resource = start_expensive_resource()\n    {input, resource}\n  end\n)\n```\n\n_When might this be useful?_\n\n* Starting a process to be used in your scenario\n* Recording the PID of `self()` for use in your benchmark (each scenario is executed in its own process, so scenario PIDs aren't available in functions running before the suite)\n* Clearing the cache before a scenario\n\n###","ref":"readme.html#before_scenario"},{"type":"extras","title":"after_scenario - Readme","doc":"Is executed after a scenario has completed. After scenario hooks receive the return value of the last `before_scenario` that ran as an argument. The return value is discarded (see [hook arguments and return values](#hook-arguments-and-return-values)).\n\nFor after scenario hooks, the _local_ hook is invoked first, then the _global_ (see [when does a hook happen?](#when-does-a-hook-happen-complete-example)).\n\nUsage:\n\n```elixir\nBenchee.run(\n  %{\n    \"bar\" => fn -> bar() end\n  },\n  after_scenario: fn _input -> bust_my_cache() end\n)\n```\n\n_When might this be useful?_\n\n* Busting caches after a scenario completed\n* Deleting all the records in the database that the scenario just created\n* Terminating whatever was setup by `before_scenario`\n\n##","ref":"readme.html#after_scenario"},{"type":"extras","title":"Benchmarking function hooks - Readme","doc":"You can also schedule hooks to run before and after each invocation of a benchmarking function.\n\n###","ref":"readme.html#benchmarking-function-hooks"},{"type":"extras","title":"before_each - Readme","doc":"Is executed before each invocation of the benchmarking function (before every measurement). Before each hooks receive the return value of their `before_scenario` hook as their argument. The return value of a before each hook becomes the input to the benchmarking function (see [hook arguments and return values](#hook-arguments-and-return-values)).\n\nFor before each hooks, the _global_ hook is invoked first, then the _local_ (see [when does a hook happen?](#when-does-a-hook-happen-complete-example)).\n\nUsage:\n\n```elixir\nBenchee.run(\n  %{\n    \"bar\" => fn record -> bar(record) end\n  },\n  inputs: %{ \"record id\" => 1},\n  before_each: fn input -> get_from_db(input) end\n)\n```\n\n_When might this be useful?_\n\n* Retrieving a record from the database and passing it on to the benchmarking function to do _something(tm)_ without the retrieval from the database adding to the benchmark measurement\n* Busting caches so that all measurements are taken in an uncached state\n* Picking a random value from a collection and passing it to the benchmarking function for measuring performance with a wider spread of values\n* you could also use this to benchmark with random data like `StreamData`, [devon shows how it's done here](https://devonestes.herokuapp.com/benchmarking-with-stream-data)\n\n###","ref":"readme.html#before_each"},{"type":"extras","title":"after_each - Readme","doc":"Is executed directly after the invocation of the benchmarking function. After each hooks receive the return value of the benchmarking function as their argument. The return value is discarded (see [hook arguments and return values](#hook-arguments-and-return-values)).\n\nFor after each hooks, the _local_ hook is invoked first, then the _global_ (see [when does a hook happen?](#when-does-a-hook-happen-complete-example)).\n\nUsage:\n\n```elixir\nBenchee.run(\n  %{\n    \"bar\" => fn input -> bar(input) end\n  },\n  inputs: %{ \"input 1\" => 1},\n  after_each: fn result -> assert result == 42 end\n)\n```\n\n_When might this be useful?_\n\n* Running assertions that whatever your benchmarking function returns is truly what it should be (i.e. all \"contestants\" work as expected)\n* Busting caches/terminating processes setup in `before_each` or elsewhere\n* Deleting files created by the benchmarking function\n\n##","ref":"readme.html#after_each"},{"type":"extras","title":"Hook arguments and return values - Readme","doc":"Before hooks form a chain, where the return value of the previous hook becomes the argument for the next one. The first defined `before` hook receives the scenario input as an argument, and returns a value that becomes the argument of the next in the chain. The benchmarking function receives the value of the last `before` hook as its argument (or the scenario input if there are no `before` hooks).\n\nAfter hooks do not form a chain, and their return values are discarded. An `after_each` hook receives the return value of the benchmarking function as its argument. An `after_scenario` function receives the return value of the last `before_scenario` that ran (or the scenario's input if there is no `before_scenario` hook).\n\nIf you haven't defined any inputs, the hook chain is started with the special input argument returned by `Benchee.Benchmark.no_input()`.\n\n##","ref":"readme.html#hook-arguments-and-return-values"},{"type":"extras","title":"Hook configuration: global versus local - Readme","doc":"Hooks can be defined either _globally_ as part of the configuration or _locally_ for a specific benchmarking function. Global hooks will be executed for every scenario in the suite. Local hooks will only be executed for scenarios involving that benchmarking function.\n\n**Global hooks**\n\nGlobal hooks are specified as part of the general benchee configuration:\n\n```elixir\nBenchee.run(\n  %{\n    \"foo\" => fn input -> ... end,\n    \"bar\" => fn input -> ... end\n  },\n  inputs: %{\n    \"input 1\" => 1,\n    \"input 2\" => 2,\n  },\n  before_scenario: fn input -> ... end\n)\n```\n\nHere the `before_scenario` function will be executed for all 4 scenarios present in this benchmarking suite.\n\n**Local hooks**\n\nLocal hooks are defined alongside the benchmarking function. To define a local hook, pass a tuple in the initial map, instead of just a single function. The benchmarking function comes first, followed by a keyword list specifying the hooks to run:\n\n```elixir\nBenchee.run(\n  %{\n    \"foo\" => {fn input -> ... end, before_scenario: fn input -> ... end},\n    \"bar\" => fn input -> ... end\n  },\n  inputs: %{\n    \"input 1\" => 1,\n    \"input 2\" => 2\n  }\n)\n```\n\nHere `before_scenario` is only run for the 2 scenarios associated with `\"foo\"`, i.e. foo with input 1 and foo with input 2. It is _not_ run for any `\"bar\"` benchmarks.\n\n\n##","ref":"readme.html#hook-configuration-global-versus-local"},{"type":"extras","title":"When does a hook happen? (Complete Example) - Readme","doc":"Yes the whole hooks system is quite a lot to take in. Here is an overview showing the order of hook execution, along with the argument each hook receives (see [hook arguments and return values](#hook-arguments-and-return-values)). The guiding principle whether _local_ or _global_ is run first is that _local_ always executes closer to the benchmarking function.\n\nGiven the following code:\n\n```elixir\n\nsuite_set_up()\n\nBenchee.run(\n  %{\n    \"foo\" =>\n      {\n        fn input -> foo(input) end,\n        before_scenario: fn input ->\n          local_before_scenario(input)\n          input + 1\n        end,\n        before_each: fn input ->\n          local_before_each(input)\n          input + 1\n        end,\n        after_each: fn value ->\n          local_after_each(value)\n        end,\n        after_scenario: fn input ->\n          local_after_scenario(input)\n        end\n      },\n    \"bar\" =>\n      fn input -> bar(input) end\n  },\n  inputs: %{\"input 1\" => 1},\n  before_scenario: fn input ->\n    global_before_scenario(input)\n    input + 1\n  end,\n  before_each: fn input ->\n    global_before_each(input)\n    input + 1\n  end,\n  after_each: fn value ->\n    global_after_each(value)\n  end,\n  after_scenario: fn input ->\n    global_after_scenario(input)\n  end\n)\n\nsuite_tear_down()\n```\n\nKeeping in mind that the order of foo and bar could be different, here is how the hooks are called:\n\n```\nsuite_set_up\n\n# starting with the foo scenario\nglobal_before_scenario(1)\nlocal_before_scenario(2) # as before_scenario incremented it\n\nglobal_before_each(3)\nlocal_before_each(4)\nfoo(5) # let's say foo(5) returns 6\nlocal_after_each(6)\nglobal_after_each(6)\n\nglobal_before_each(3)\nlocal_before_each(4)\nfoo(5) # let's say foo(5) returns 6\nlocal_after_each(6)\nglobal_after_each(6)\n\n# ... this block is repeated as many times as benchee has time\n\nlocal_after_scenario(3)\nglobal_after_scenario(3)\n\n# now it's time for the bar scenario, it has no hooks specified for itself\n# so only the global hooks are run\n\nglobal_before_scenario(1)\n\nglobal_before_each(2)\nbar(3) # let's say foo(3) returns 4\nglobal_after_each(4)\n\nglobal_before_each(2)\nbar(3) # let's say foo(3) returns 4\nglobal_after_each(4)\n\n# ... this block is repeated as many times as benchee has time\n\nglobal_after_scenario(2)\n\nsuite_tear_down\n```\n\n#","ref":"readme.html#when-does-a-hook-happen-complete-example"},{"type":"extras","title":"More verbose usage - Readme","doc":"It is important to note that the benchmarking code shown in the beginning is the convenience interface. The same benchmark in its more verbose form looks like this:\n\n```elixir\nlist = Enum.to_list(1..10_000)\nmap_fun = fn i -> [i, i * i] end\n\n[time: 3]\n|> Benchee.init()\n|> Benchee.system()\n|> Benchee.benchmark(\"flat_map\", fn -> Enum.flat_map(list, map_fun) end)\n|> Benchee.benchmark(\n  \"map.flatten\",\n  fn -> list |> Enum.map(map_fun) |> List.flatten() end\n)\n|> Benchee.collect()\n|> Benchee.statistics()\n|> Benchee.relative_statistics()\n|> Benchee.Formatter.output(Benchee.Formatters.Console)\n# Instead of the last call you could also just use Benchee.Formatter.output()\n# to just output all configured formatters\n```\n\nThis is a take on the _functional transformation_ of data applied to benchmarks:\n\n1. Configure the benchmarking suite to be run\n2. Gather System data\n3. Define the functions to be benchmarked\n4. Run benchmarks with the given configuration gathering raw run times per function\n5. Calculate statistics based on the raw run times\n6. Calculate statistics between the scenarios (faster/slower...)\n7. Format the statistics in a suitable way and print them out\n\nThis is also part of the **official API** and allows for more **fine grained control**. (It's also what Benchee does internally when you use `Benchee.run/2`).\n\nDo you just want to have all the raw run times? Just work with the result of `Benchee.collect/1`! Just want to have the calculated statistics and use your own formatting? Grab the result of `Benchee.statistics/1`! Or, maybe you want to write to a file or send an HTTP post to some online service? Just grab the complete suite after statistics were generated.\n\nIt also allows you to alter behaviour, normally `Benchee.load/1` is called right before the formatters so that neither the benchmarks are run again or statistics are computed again. However, you might want to run the benchmarks again or recompute the statistics. Then you can call `Benchee.load/1` right at the start.\n\nThis way Benchee should be flexible enough to suit your needs and be extended at will. Have a look at the [available plugins](#plugins).\n\n#","ref":"readme.html#more-verbose-usage"},{"type":"extras","title":"Usage from Erlang - Readme","doc":"Before you dig deep into this, it is inherently easier to setup a small elixir project, add a dependency to your erlang project and then run the benchmarks from elixir. The reason is easy - mix knows about rebar3 and knows how to work with it. The reverse isn't true so the road ahead is somewhat bumpy.\n\nThere is an [example project](https://github.com/bencheeorg/benchee_erlang_try) to check out.\n\nYou can use the [rebar3_elixir_compile](https://github.com/barrel-db/rebar3_elixir_compile) plugin. In your `rebar.config` you can do the following which should get you started:\n\n```erlang\ndeps, [\n  {benchee, {elixir, \"benchee\", \"0.9.0\"}}\n]}.\n\n{plugins, [\n    { rebar3_elixir_compile, \".*\", {git, \"https://github.com/barrel-db/rebar3_elixir_compile.git\", {branch, \"main\"}}}\n]}.\n\n{provider_hooks, [\n  {pre, [{compile, {ex, compile}}]},\n  {pre, [{release, {ex, compile}}]}\n]}.\n\n{elixir_opts,\n  [\n    {env, dev}\n  ]\n}.\n```\n\nThen benchee already provides a `:benchee` interface for erlang compatibility which you can use. Sadly couldn't get it to work in an escript yet.\n\nYou can then invoke it like this (for instance):\n\n```\ntobi@comfy ~/github/benchee_erlang_try $ rebar3 shell\n===> dependencies etc.\nErlang/OTP 18 [erts-7.3] [source] [64-bit] [smp:4:4] [async-threads:0] [hipe] [kernel-poll:false]\n\nEshell V7.3  (abort with ^G)\n1> benchee:run(#{myFunc => fun() -> lists:sort([8, 2, 3, 4, 2, 1, 3, 4, 9, 10, 11, 12, 13, 20, 1000, -4, -5]) end}, [{warmup, 0}, {time, 2}]).\nOperating System: Linux\nCPU Information: Intel(R) Core(TM) i5-7200U CPU @ 2.50GHz\nNumber of Available Cores: 4\nAvailable memory: 8.05 GB\nElixir 1.3.4\nErlang 18.3\nBenchmark suite executing with the following configuration:\nwarmup: 0.0 μs\ntime: 2 s\nparallel: 1\ninputs: none specified\nEstimated total run time: 2 s\n\n\nBenchmarking myFunc...\n\nName             ips        average  deviation         median\nmyFunc      289.71 K        3.45 μs   ±250.31%           3 μs\n```\n\nThis doesn't seem to be too reliable right now, so suggestions and input are very welcome :)","ref":"readme.html#usage-from-erlang"},{"type":"extras","title":"Known Issues - Readme","doc":"There is a known issue affecting elixir versions from 1.14.0 to 1.16.0-rc.0: Optimizations (SSA and bool passes, [see the original change](https://github.com/elixir-lang/elixir/pull/11420)) had been disabled affecting the performance of functions defined directly in the top level (i.e. outside of any module). The issue was fixed by re-enabling the optimization in [1.16.0-rc.1](https://github.com/elixir-lang/elixir/blob/v1.16/CHANGELOG.md#v1160-rc1-2023-12-12).\nThe issue is best show-cased by the following benchmark where we'd expect ~equal results:\n\n```elixir\nlist = Enum.to_list(1..10_000)\n\ndefmodule Compiled do\n  def comprehension(list) do\n    for x <- list, rem(x, 2) == 1, do: x + 1\n  end\nend\n\nBenchee.run(%{\n  \"module (optimized)\" => fn -> Compiled.comprehension(list) end,\n  \"top_level (non-optimized)\" => fn -> for x <- list, rem(x, 2) == 1, do: x + 1 end\n})\n```\n\nWhich yields ~these results on an affected elixir version:\n\n```\nComparison:\nmodule (optimized)              18.24 K\ntop_level (non-optimized)       11.91 K - 1.53x slower +29.14 μs\n```\n\nSo, how do you fix it/make sure a benchmark you ran is not affected? All of these work:\n\n* benchmark on an unaffected/fixed version of elixir (<= 1.13.4 or >= 1.16.0-rc.1)\n* put the code you want to benchmark into a module (just like it is done in `Compiled` in the example above)\n* you can also invoke benchee from within a module, such as:\n\n```\ndefmodule Compiled do\n  def comprehension(list) do\n    for x <- list, rem(x, 2) == 1, do: x + 1\n  end\nend\n\ndefmodule MyBenchmark do\n  def run do\n    list = Enum.to_list(1..10_000)\n\n    Benchee.run(%{\n      \"module (optimized)\" => fn -> Compiled.comprehension(list) end,\n      \"top_level (non-optimized)\" => fn -> for x <- list, rem(x, 2) == 1, do: x + 1 end\n    })\n  end\nend\n\nMyBenchmark.run()\n```\n\nAlso note that even if all your examples are top level functions you should still follow these tips (on affected elixir versions), as the missing optimization might affect them differently. Further note, that even though your examples use top level functions they _may_ not be affected, as the specific disabled optimization may not impact them. Better safe than sorry though :)","ref":"readme.html#known-issues"},{"type":"extras","title":"Plugins - Readme","doc":"Benchee only has small runtime dependencies that were initially extracted from it. Further functionality is provided through plugins that then pull in dependencies, such as HTML generation and CSV export. They help provide excellent visualization or interoperability.\n\n* [benchee_html](//github.com/bencheeorg/benchee_html) - generate HTML including a data table and many different graphs with the possibility to export individual graphs as PNG :)\n* [benchee_csv](//github.com/bencheeorg/benchee_csv) - generate CSV from your benchee benchmark results so you can import them into your favorite spreadsheet tool and make fancy graphs\n* [benchee_json](//github.com/bencheeorg/benchee_json) - export suite results as JSON to feed anywhere or feed it to your JavaScript and make magic happen :)\n* [benchee_markdown](//github.com/hrzndhrn/benchee_markdown) - write markdown files containing your benchmarking results\n\nWith the HTML plugin for instance you can get fancy graphs like this boxplot:\n\n![boxplot](http://www.pragtob.info/benchee/images/boxplot.png)\n\nOf course there also are normal bar charts including standard deviation:\n\n![flat_map_ips](http://www.pragtob.info/benchee/images/flat_map_ips.png)","ref":"readme.html#plugins"},{"type":"extras","title":"Contributing [![Open Source Helpers](https://www.codetriage.com/pragtob/benchee/badges/users.svg)](https://www.codetriage.com/pragtob/benchee) - Readme","doc":"Contributions to Benchee are **very welcome**! Bug reports, documentation, spelling corrections, whole features, feature ideas, bugfixes, new plugins, fancy graphics... all of those (and probably more) are much appreciated contributions!\n\nKeep in mind that the [plugins](#plugins) live in their own repositories with their own issue tracker and they also like to get contributions :)\n\nPlease respect the [Code of Conduct](//github.com/bencheeorg/benchee/blob/main/CODE_OF_CONDUCT.md).\n\nIn addition to contributing code, you can help to triage issues. This can include reproducing bug reports, or asking for vital information such as version numbers or reproduction instructions. If you would like to start triaging issues, one easy way to get started is to [subscribe to pragtob/benchee on CodeTriage](https://www.codetriage.com/pragtob/benchee).\n\nYou can also look directly at the [open issues](https://github.com/bencheeorg/benchee/issues). There are `help wanted` and `good first issue` labels - those are meant as guidance, of course other issues can be tackled :)\n\nA couple of (hopefully) helpful points:\n\n* Feel free to ask for help and guidance on an issue/PR (\"How can I implement this?\", \"How could I test this?\", ...)\n* Feel free to open early/not yet complete pull requests to get some early feedback\n* When in doubt if something is a good idea open an issue first to discuss it\n* In case I don't respond feel free to bump the issue/PR or ping me in other places\n\nIf you're on the [elixir-lang slack](https://elixir-lang.slack.com) also feel free to drop by in `#benchee` and say hi!","ref":"readme.html#contributing-open-source-helpers-https-www-codetriage-com-pragtob-benchee-badges-users-svg-https-www-codetriage-com-pragtob-benchee"},{"type":"extras","title":"Development - Readme","doc":"Note that if the change includes adding new statistics you might need to introduce them to our statistics library [Statistex](https://github.com/bencheeorg/statistex) first!\n\n* `mix deps.get` to install dependencies\n* `mix test` to run tests\n* `mix dialyzer` to run dialyzer for type checking, might take a while on the first invocation (try building plts first with `mix dialyzer --plt`)\n* `mix credo` to find code style problems\n* or run `mix guard` to run all of them continuously on file change","ref":"readme.html#development"},{"type":"extras","title":"Copyright and License - Readme","doc":"Copyright (c) 2016 Tobias Pfeiffer\n\nThis work is free. You can redistribute it and/or modify it under the\nterms of the MIT License. See the [LICENSE.md](./LICENSE.md) file for more details.","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown"}